"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateListEventActions = void 0;
const ListEventActionsCommand_1 = require("../commands/ListEventActionsCommand");
const DataExchange_1 = require("../DataExchange");
const DataExchangeClient_1 = require("../DataExchangeClient");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new ListEventActionsCommand_1.ListEventActionsCommand(input), ...args);
};
const makePagedRequest = async (client, input, ...args) => {
    return await client.listEventActions(input, ...args);
};
async function* paginateListEventActions(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        input["MaxResults"] = config.pageSize;
        if (config.client instanceof DataExchange_1.DataExchange) {
            page = await makePagedRequest(config.client, input, ...additionalArguments);
        }
        else if (config.client instanceof DataExchangeClient_1.DataExchangeClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected DataExchange | DataExchangeClient");
        }
        yield page;
        token = page.NextToken;
        hasNext = !!token;
    }
    return undefined;
}
exports.paginateListEventActions = paginateListEventActions;
