import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateEventActionRequest, CreateEventActionResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateEventActionCommand, serializeAws_restJson1CreateEventActionCommand, } from "../protocols/Aws_restJson1";
var CreateEventActionCommand = (function (_super) {
    __extends(CreateEventActionCommand, _super);
    function CreateEventActionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateEventActionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "CreateEventActionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateEventActionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateEventActionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateEventActionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateEventActionCommand(input, context);
    };
    CreateEventActionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateEventActionCommand(output, context);
    };
    return CreateEventActionCommand;
}($Command));
export { CreateEventActionCommand };
