import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateRevisionRequest, CreateRevisionResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateRevisionCommand, serializeAws_restJson1CreateRevisionCommand, } from "../protocols/Aws_restJson1";
var CreateRevisionCommand = (function (_super) {
    __extends(CreateRevisionCommand, _super);
    function CreateRevisionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateRevisionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "CreateRevisionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateRevisionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateRevisionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateRevisionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateRevisionCommand(input, context);
    };
    CreateRevisionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateRevisionCommand(output, context);
    };
    return CreateRevisionCommand;
}($Command));
export { CreateRevisionCommand };
