import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteAssetRequest } from "../models/models_0";
import { deserializeAws_restJson1DeleteAssetCommand, serializeAws_restJson1DeleteAssetCommand, } from "../protocols/Aws_restJson1";
var DeleteAssetCommand = (function (_super) {
    __extends(DeleteAssetCommand, _super);
    function DeleteAssetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteAssetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "DeleteAssetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteAssetRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteAssetCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteAssetCommand(input, context);
    };
    DeleteAssetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteAssetCommand(output, context);
    };
    return DeleteAssetCommand;
}($Command));
export { DeleteAssetCommand };
