import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteDataSetRequest } from "../models/models_0";
import { deserializeAws_restJson1DeleteDataSetCommand, serializeAws_restJson1DeleteDataSetCommand, } from "../protocols/Aws_restJson1";
var DeleteDataSetCommand = (function (_super) {
    __extends(DeleteDataSetCommand, _super);
    function DeleteDataSetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteDataSetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "DeleteDataSetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteDataSetRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteDataSetCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteDataSetCommand(input, context);
    };
    DeleteDataSetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteDataSetCommand(output, context);
    };
    return DeleteDataSetCommand;
}($Command));
export { DeleteDataSetCommand };
