import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteEventActionRequest } from "../models/models_0";
import { deserializeAws_restJson1DeleteEventActionCommand, serializeAws_restJson1DeleteEventActionCommand, } from "../protocols/Aws_restJson1";
var DeleteEventActionCommand = (function (_super) {
    __extends(DeleteEventActionCommand, _super);
    function DeleteEventActionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteEventActionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "DeleteEventActionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteEventActionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteEventActionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteEventActionCommand(input, context);
    };
    DeleteEventActionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteEventActionCommand(output, context);
    };
    return DeleteEventActionCommand;
}($Command));
export { DeleteEventActionCommand };
