import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteRevisionRequest } from "../models/models_0";
import { deserializeAws_restJson1DeleteRevisionCommand, serializeAws_restJson1DeleteRevisionCommand, } from "../protocols/Aws_restJson1";
var DeleteRevisionCommand = (function (_super) {
    __extends(DeleteRevisionCommand, _super);
    function DeleteRevisionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteRevisionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "DeleteRevisionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteRevisionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteRevisionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteRevisionCommand(input, context);
    };
    DeleteRevisionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteRevisionCommand(output, context);
    };
    return DeleteRevisionCommand;
}($Command));
export { DeleteRevisionCommand };
