import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetEventActionRequest, GetEventActionResponse } from "../models/models_0";
import { deserializeAws_restJson1GetEventActionCommand, serializeAws_restJson1GetEventActionCommand, } from "../protocols/Aws_restJson1";
var GetEventActionCommand = (function (_super) {
    __extends(GetEventActionCommand, _super);
    function GetEventActionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetEventActionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "GetEventActionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetEventActionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetEventActionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetEventActionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetEventActionCommand(input, context);
    };
    GetEventActionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetEventActionCommand(output, context);
    };
    return GetEventActionCommand;
}($Command));
export { GetEventActionCommand };
