import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetRevisionRequest, GetRevisionResponse } from "../models/models_0";
import { deserializeAws_restJson1GetRevisionCommand, serializeAws_restJson1GetRevisionCommand, } from "../protocols/Aws_restJson1";
var GetRevisionCommand = (function (_super) {
    __extends(GetRevisionCommand, _super);
    function GetRevisionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetRevisionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "GetRevisionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetRevisionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetRevisionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetRevisionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetRevisionCommand(input, context);
    };
    GetRevisionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetRevisionCommand(output, context);
    };
    return GetRevisionCommand;
}($Command));
export { GetRevisionCommand };
