import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListDataSetRevisionsRequest, ListDataSetRevisionsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListDataSetRevisionsCommand, serializeAws_restJson1ListDataSetRevisionsCommand, } from "../protocols/Aws_restJson1";
var ListDataSetRevisionsCommand = (function (_super) {
    __extends(ListDataSetRevisionsCommand, _super);
    function ListDataSetRevisionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListDataSetRevisionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "ListDataSetRevisionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListDataSetRevisionsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListDataSetRevisionsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListDataSetRevisionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListDataSetRevisionsCommand(input, context);
    };
    ListDataSetRevisionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListDataSetRevisionsCommand(output, context);
    };
    return ListDataSetRevisionsCommand;
}($Command));
export { ListDataSetRevisionsCommand };
