import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListEventActionsRequest, ListEventActionsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListEventActionsCommand, serializeAws_restJson1ListEventActionsCommand, } from "../protocols/Aws_restJson1";
var ListEventActionsCommand = (function (_super) {
    __extends(ListEventActionsCommand, _super);
    function ListEventActionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListEventActionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "ListEventActionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListEventActionsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListEventActionsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListEventActionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListEventActionsCommand(input, context);
    };
    ListEventActionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListEventActionsCommand(output, context);
    };
    return ListEventActionsCommand;
}($Command));
export { ListEventActionsCommand };
