import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { RevokeRevisionRequest, RevokeRevisionResponse } from "../models/models_0";
import { deserializeAws_restJson1RevokeRevisionCommand, serializeAws_restJson1RevokeRevisionCommand, } from "../protocols/Aws_restJson1";
var RevokeRevisionCommand = (function (_super) {
    __extends(RevokeRevisionCommand, _super);
    function RevokeRevisionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    RevokeRevisionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "RevokeRevisionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: RevokeRevisionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: RevokeRevisionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    RevokeRevisionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1RevokeRevisionCommand(input, context);
    };
    RevokeRevisionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1RevokeRevisionCommand(output, context);
    };
    return RevokeRevisionCommand;
}($Command));
export { RevokeRevisionCommand };
