import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SendApiAssetRequest, SendApiAssetResponse } from "../models/models_0";
import { deserializeAws_restJson1SendApiAssetCommand, serializeAws_restJson1SendApiAssetCommand, } from "../protocols/Aws_restJson1";
var SendApiAssetCommand = (function (_super) {
    __extends(SendApiAssetCommand, _super);
    function SendApiAssetCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    SendApiAssetCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "SendApiAssetCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: SendApiAssetRequest.filterSensitiveLog,
            outputFilterSensitiveLog: SendApiAssetResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    SendApiAssetCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1SendApiAssetCommand(input, context);
    };
    SendApiAssetCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1SendApiAssetCommand(output, context);
    };
    return SendApiAssetCommand;
}($Command));
export { SendApiAssetCommand };
