import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { StartJobRequest, StartJobResponse } from "../models/models_0";
import { deserializeAws_restJson1StartJobCommand, serializeAws_restJson1StartJobCommand, } from "../protocols/Aws_restJson1";
var StartJobCommand = (function (_super) {
    __extends(StartJobCommand, _super);
    function StartJobCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    StartJobCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "StartJobCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: StartJobRequest.filterSensitiveLog,
            outputFilterSensitiveLog: StartJobResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    StartJobCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1StartJobCommand(input, context);
    };
    StartJobCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1StartJobCommand(output, context);
    };
    return StartJobCommand;
}($Command));
export { StartJobCommand };
