import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateEventActionRequest, UpdateEventActionResponse } from "../models/models_0";
import { deserializeAws_restJson1UpdateEventActionCommand, serializeAws_restJson1UpdateEventActionCommand, } from "../protocols/Aws_restJson1";
var UpdateEventActionCommand = (function (_super) {
    __extends(UpdateEventActionCommand, _super);
    function UpdateEventActionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateEventActionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "UpdateEventActionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateEventActionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateEventActionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateEventActionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UpdateEventActionCommand(input, context);
    };
    UpdateEventActionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UpdateEventActionCommand(output, context);
    };
    return UpdateEventActionCommand;
}($Command));
export { UpdateEventActionCommand };
