import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateRevisionRequest, UpdateRevisionResponse } from "../models/models_0";
import { deserializeAws_restJson1UpdateRevisionCommand, serializeAws_restJson1UpdateRevisionCommand, } from "../protocols/Aws_restJson1";
var UpdateRevisionCommand = (function (_super) {
    __extends(UpdateRevisionCommand, _super);
    function UpdateRevisionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateRevisionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "DataExchangeClient";
        var commandName = "UpdateRevisionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateRevisionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpdateRevisionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateRevisionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UpdateRevisionCommand(input, context);
    };
    UpdateRevisionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UpdateRevisionCommand(output, context);
    };
    return UpdateRevisionCommand;
}($Command));
export { UpdateRevisionCommand };
