import { __assign, __extends } from "tslib";
import { DataExchangeServiceException as __BaseException } from "./DataExchangeServiceException";
var AccessDeniedException = (function (_super) {
    __extends(AccessDeniedException, _super);
    function AccessDeniedException(opts) {
        var _this = _super.call(this, __assign({ name: "AccessDeniedException", $fault: "client" }, opts)) || this;
        _this.name = "AccessDeniedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, AccessDeniedException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return AccessDeniedException;
}(__BaseException));
export { AccessDeniedException };
export var ServerSideEncryptionTypes;
(function (ServerSideEncryptionTypes) {
    ServerSideEncryptionTypes["AES256"] = "AES256";
    ServerSideEncryptionTypes["aws_kms"] = "aws:kms";
})(ServerSideEncryptionTypes || (ServerSideEncryptionTypes = {}));
export var ExportServerSideEncryption;
(function (ExportServerSideEncryption) {
    ExportServerSideEncryption.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportServerSideEncryption || (ExportServerSideEncryption = {}));
export var AutoExportRevisionDestinationEntry;
(function (AutoExportRevisionDestinationEntry) {
    AutoExportRevisionDestinationEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AutoExportRevisionDestinationEntry || (AutoExportRevisionDestinationEntry = {}));
export var AutoExportRevisionToS3RequestDetails;
(function (AutoExportRevisionToS3RequestDetails) {
    AutoExportRevisionToS3RequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AutoExportRevisionToS3RequestDetails || (AutoExportRevisionToS3RequestDetails = {}));
export var Action;
(function (Action) {
    Action.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Action || (Action = {}));
export var ProtocolType;
(function (ProtocolType) {
    ProtocolType["REST"] = "REST";
})(ProtocolType || (ProtocolType = {}));
export var ApiGatewayApiAsset;
(function (ApiGatewayApiAsset) {
    ApiGatewayApiAsset.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ApiGatewayApiAsset || (ApiGatewayApiAsset = {}));
export var AssetDestinationEntry;
(function (AssetDestinationEntry) {
    AssetDestinationEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AssetDestinationEntry || (AssetDestinationEntry = {}));
export var RedshiftDataShareAsset;
(function (RedshiftDataShareAsset) {
    RedshiftDataShareAsset.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RedshiftDataShareAsset || (RedshiftDataShareAsset = {}));
export var S3SnapshotAsset;
(function (S3SnapshotAsset) {
    S3SnapshotAsset.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3SnapshotAsset || (S3SnapshotAsset = {}));
export var AssetDetails;
(function (AssetDetails) {
    AssetDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AssetDetails || (AssetDetails = {}));
export var AssetType;
(function (AssetType) {
    AssetType["API_GATEWAY_API"] = "API_GATEWAY_API";
    AssetType["REDSHIFT_DATA_SHARE"] = "REDSHIFT_DATA_SHARE";
    AssetType["S3_SNAPSHOT"] = "S3_SNAPSHOT";
})(AssetType || (AssetType = {}));
export var AssetEntry;
(function (AssetEntry) {
    AssetEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AssetEntry || (AssetEntry = {}));
export var AssetSourceEntry;
(function (AssetSourceEntry) {
    AssetSourceEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(AssetSourceEntry || (AssetSourceEntry = {}));
export var CancelJobRequest;
(function (CancelJobRequest) {
    CancelJobRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CancelJobRequest || (CancelJobRequest = {}));
export var ResourceType;
(function (ResourceType) {
    ResourceType["ASSET"] = "ASSET";
    ResourceType["DATA_SET"] = "DATA_SET";
    ResourceType["EVENT_ACTION"] = "EVENT_ACTION";
    ResourceType["JOB"] = "JOB";
    ResourceType["REVISION"] = "REVISION";
})(ResourceType || (ResourceType = {}));
var ConflictException = (function (_super) {
    __extends(ConflictException, _super);
    function ConflictException(opts) {
        var _this = _super.call(this, __assign({ name: "ConflictException", $fault: "client" }, opts)) || this;
        _this.name = "ConflictException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConflictException.prototype);
        _this.Message = opts.Message;
        _this.ResourceId = opts.ResourceId;
        _this.ResourceType = opts.ResourceType;
        return _this;
    }
    return ConflictException;
}(__BaseException));
export { ConflictException };
var InternalServerException = (function (_super) {
    __extends(InternalServerException, _super);
    function InternalServerException(opts) {
        var _this = _super.call(this, __assign({ name: "InternalServerException", $fault: "server" }, opts)) || this;
        _this.name = "InternalServerException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, InternalServerException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InternalServerException;
}(__BaseException));
export { InternalServerException };
var ResourceNotFoundException = (function (_super) {
    __extends(ResourceNotFoundException, _super);
    function ResourceNotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceNotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceNotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceNotFoundException.prototype);
        _this.Message = opts.Message;
        _this.ResourceId = opts.ResourceId;
        _this.ResourceType = opts.ResourceType;
        return _this;
    }
    return ResourceNotFoundException;
}(__BaseException));
export { ResourceNotFoundException };
var ThrottlingException = (function (_super) {
    __extends(ThrottlingException, _super);
    function ThrottlingException(opts) {
        var _this = _super.call(this, __assign({ name: "ThrottlingException", $fault: "client" }, opts)) || this;
        _this.name = "ThrottlingException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ThrottlingException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ThrottlingException;
}(__BaseException));
export { ThrottlingException };
export var ExceptionCause;
(function (ExceptionCause) {
    ExceptionCause["InsufficientS3BucketPolicy"] = "InsufficientS3BucketPolicy";
    ExceptionCause["S3AccessDenied"] = "S3AccessDenied";
})(ExceptionCause || (ExceptionCause = {}));
var ValidationException = (function (_super) {
    __extends(ValidationException, _super);
    function ValidationException(opts) {
        var _this = _super.call(this, __assign({ name: "ValidationException", $fault: "client" }, opts)) || this;
        _this.name = "ValidationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ValidationException.prototype);
        _this.Message = opts.Message;
        _this.ExceptionCause = opts.ExceptionCause;
        return _this;
    }
    return ValidationException;
}(__BaseException));
export { ValidationException };
export var Code;
(function (Code) {
    Code["ACCESS_DENIED_EXCEPTION"] = "ACCESS_DENIED_EXCEPTION";
    Code["INTERNAL_SERVER_EXCEPTION"] = "INTERNAL_SERVER_EXCEPTION";
    Code["MALWARE_DETECTED"] = "MALWARE_DETECTED";
    Code["MALWARE_SCAN_ENCRYPTED_FILE"] = "MALWARE_SCAN_ENCRYPTED_FILE";
    Code["RESOURCE_NOT_FOUND_EXCEPTION"] = "RESOURCE_NOT_FOUND_EXCEPTION";
    Code["SERVICE_QUOTA_EXCEEDED_EXCEPTION"] = "SERVICE_QUOTA_EXCEEDED_EXCEPTION";
    Code["VALIDATION_EXCEPTION"] = "VALIDATION_EXCEPTION";
})(Code || (Code = {}));
export var CreateDataSetRequest;
(function (CreateDataSetRequest) {
    CreateDataSetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateDataSetRequest || (CreateDataSetRequest = {}));
export var Origin;
(function (Origin) {
    Origin["ENTITLED"] = "ENTITLED";
    Origin["OWNED"] = "OWNED";
})(Origin || (Origin = {}));
export var OriginDetails;
(function (OriginDetails) {
    OriginDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(OriginDetails || (OriginDetails = {}));
export var CreateDataSetResponse;
(function (CreateDataSetResponse) {
    CreateDataSetResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateDataSetResponse || (CreateDataSetResponse = {}));
export var LimitName;
(function (LimitName) {
    LimitName["Amazon_API_Gateway_API_assets_per_revision"] = "Amazon API Gateway API assets per revision";
    LimitName["Amazon_Redshift_datashare_assets_per_import_job_from_Redshift"] = "Amazon Redshift datashare assets per import job from Redshift";
    LimitName["Amazon_Redshift_datashare_assets_per_revision"] = "Amazon Redshift datashare assets per revision";
    LimitName["Asset_per_export_job_from_Amazon_S3"] = "Asset per export job from Amazon S3";
    LimitName["Asset_size_in_GB"] = "Asset size in GB";
    LimitName["Assets_per_import_job_from_Amazon_S3"] = "Assets per import job from Amazon S3";
    LimitName["Assets_per_revision"] = "Assets per revision";
    LimitName["Auto_export_event_actions_per_data_set"] = "Auto export event actions per data set";
    LimitName["Concurrent_in_progress_jobs_to_export_assets_to_Amazon_S3"] = "Concurrent in progress jobs to export assets to Amazon S3";
    LimitName["Concurrent_in_progress_jobs_to_export_assets_to_a_signed_URL"] = "Concurrent in progress jobs to export assets to a signed URL";
    LimitName["Concurrent_in_progress_jobs_to_export_revisions_to_Amazon_S3"] = "Concurrent in progress jobs to export revisions to Amazon S3";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_Amazon_Redshift_datashares"] = "Concurrent in progress jobs to import assets from Amazon Redshift datashares";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_Amazon_S3"] = "Concurrent in progress jobs to import assets from Amazon S3";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_a_signed_URL"] = "Concurrent in progress jobs to import assets from a signed URL";
    LimitName["Concurrent_in_progress_jobs_to_import_assets_from_an_API_Gateway_API"] = "Concurrent in progress jobs to import assets from an API Gateway API";
    LimitName["Data_sets_per_account"] = "Data sets per account";
    LimitName["Data_sets_per_product"] = "Data sets per product";
    LimitName["Event_actions_per_account"] = "Event actions per account";
    LimitName["Products_per_account"] = "Products per account";
    LimitName["Revisions_per_Amazon_API_Gateway_API_data_set"] = "Revisions per Amazon API Gateway API data set";
    LimitName["Revisions_per_Amazon_Redshift_datashare_data_set"] = "Revisions per Amazon Redshift datashare data set";
    LimitName["Revisions_per_data_set"] = "Revisions per data set";
})(LimitName || (LimitName = {}));
var ServiceLimitExceededException = (function (_super) {
    __extends(ServiceLimitExceededException, _super);
    function ServiceLimitExceededException(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceLimitExceededException", $fault: "client" }, opts)) || this;
        _this.name = "ServiceLimitExceededException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ServiceLimitExceededException.prototype);
        _this.LimitName = opts.LimitName;
        _this.LimitValue = opts.LimitValue;
        _this.Message = opts.Message;
        return _this;
    }
    return ServiceLimitExceededException;
}(__BaseException));
export { ServiceLimitExceededException };
export var RevisionPublished;
(function (RevisionPublished) {
    RevisionPublished.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RevisionPublished || (RevisionPublished = {}));
export var Event;
(function (Event) {
    Event.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Event || (Event = {}));
export var CreateEventActionRequest;
(function (CreateEventActionRequest) {
    CreateEventActionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateEventActionRequest || (CreateEventActionRequest = {}));
export var CreateEventActionResponse;
(function (CreateEventActionResponse) {
    CreateEventActionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateEventActionResponse || (CreateEventActionResponse = {}));
export var ExportAssetsToS3RequestDetails;
(function (ExportAssetsToS3RequestDetails) {
    ExportAssetsToS3RequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportAssetsToS3RequestDetails || (ExportAssetsToS3RequestDetails = {}));
export var ExportAssetToSignedUrlRequestDetails;
(function (ExportAssetToSignedUrlRequestDetails) {
    ExportAssetToSignedUrlRequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportAssetToSignedUrlRequestDetails || (ExportAssetToSignedUrlRequestDetails = {}));
export var RevisionDestinationEntry;
(function (RevisionDestinationEntry) {
    RevisionDestinationEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RevisionDestinationEntry || (RevisionDestinationEntry = {}));
export var ExportRevisionsToS3RequestDetails;
(function (ExportRevisionsToS3RequestDetails) {
    ExportRevisionsToS3RequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportRevisionsToS3RequestDetails || (ExportRevisionsToS3RequestDetails = {}));
export var ImportAssetFromApiGatewayApiRequestDetails;
(function (ImportAssetFromApiGatewayApiRequestDetails) {
    ImportAssetFromApiGatewayApiRequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetFromApiGatewayApiRequestDetails || (ImportAssetFromApiGatewayApiRequestDetails = {}));
export var ImportAssetFromSignedUrlRequestDetails;
(function (ImportAssetFromSignedUrlRequestDetails) {
    ImportAssetFromSignedUrlRequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetFromSignedUrlRequestDetails || (ImportAssetFromSignedUrlRequestDetails = {}));
export var RedshiftDataShareAssetSourceEntry;
(function (RedshiftDataShareAssetSourceEntry) {
    RedshiftDataShareAssetSourceEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RedshiftDataShareAssetSourceEntry || (RedshiftDataShareAssetSourceEntry = {}));
export var ImportAssetsFromRedshiftDataSharesRequestDetails;
(function (ImportAssetsFromRedshiftDataSharesRequestDetails) {
    ImportAssetsFromRedshiftDataSharesRequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetsFromRedshiftDataSharesRequestDetails || (ImportAssetsFromRedshiftDataSharesRequestDetails = {}));
export var ImportAssetsFromS3RequestDetails;
(function (ImportAssetsFromS3RequestDetails) {
    ImportAssetsFromS3RequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetsFromS3RequestDetails || (ImportAssetsFromS3RequestDetails = {}));
export var RequestDetails;
(function (RequestDetails) {
    RequestDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RequestDetails || (RequestDetails = {}));
export var Type;
(function (Type) {
    Type["EXPORT_ASSETS_TO_S3"] = "EXPORT_ASSETS_TO_S3";
    Type["EXPORT_ASSET_TO_SIGNED_URL"] = "EXPORT_ASSET_TO_SIGNED_URL";
    Type["EXPORT_REVISIONS_TO_S3"] = "EXPORT_REVISIONS_TO_S3";
    Type["IMPORT_ASSETS_FROM_REDSHIFT_DATA_SHARES"] = "IMPORT_ASSETS_FROM_REDSHIFT_DATA_SHARES";
    Type["IMPORT_ASSETS_FROM_S3"] = "IMPORT_ASSETS_FROM_S3";
    Type["IMPORT_ASSET_FROM_API_GATEWAY_API"] = "IMPORT_ASSET_FROM_API_GATEWAY_API";
    Type["IMPORT_ASSET_FROM_SIGNED_URL"] = "IMPORT_ASSET_FROM_SIGNED_URL";
})(Type || (Type = {}));
export var CreateJobRequest;
(function (CreateJobRequest) {
    CreateJobRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateJobRequest || (CreateJobRequest = {}));
export var ExportAssetsToS3ResponseDetails;
(function (ExportAssetsToS3ResponseDetails) {
    ExportAssetsToS3ResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportAssetsToS3ResponseDetails || (ExportAssetsToS3ResponseDetails = {}));
export var ExportAssetToSignedUrlResponseDetails;
(function (ExportAssetToSignedUrlResponseDetails) {
    ExportAssetToSignedUrlResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportAssetToSignedUrlResponseDetails || (ExportAssetToSignedUrlResponseDetails = {}));
export var ExportRevisionsToS3ResponseDetails;
(function (ExportRevisionsToS3ResponseDetails) {
    ExportRevisionsToS3ResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExportRevisionsToS3ResponseDetails || (ExportRevisionsToS3ResponseDetails = {}));
export var ImportAssetFromApiGatewayApiResponseDetails;
(function (ImportAssetFromApiGatewayApiResponseDetails) {
    ImportAssetFromApiGatewayApiResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetFromApiGatewayApiResponseDetails || (ImportAssetFromApiGatewayApiResponseDetails = {}));
export var ImportAssetFromSignedUrlResponseDetails;
(function (ImportAssetFromSignedUrlResponseDetails) {
    ImportAssetFromSignedUrlResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetFromSignedUrlResponseDetails || (ImportAssetFromSignedUrlResponseDetails = {}));
export var ImportAssetsFromRedshiftDataSharesResponseDetails;
(function (ImportAssetsFromRedshiftDataSharesResponseDetails) {
    ImportAssetsFromRedshiftDataSharesResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetsFromRedshiftDataSharesResponseDetails || (ImportAssetsFromRedshiftDataSharesResponseDetails = {}));
export var ImportAssetsFromS3ResponseDetails;
(function (ImportAssetsFromS3ResponseDetails) {
    ImportAssetsFromS3ResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetsFromS3ResponseDetails || (ImportAssetsFromS3ResponseDetails = {}));
export var ResponseDetails;
(function (ResponseDetails) {
    ResponseDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ResponseDetails || (ResponseDetails = {}));
export var ImportAssetFromSignedUrlJobErrorDetails;
(function (ImportAssetFromSignedUrlJobErrorDetails) {
    ImportAssetFromSignedUrlJobErrorDetails.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ImportAssetFromSignedUrlJobErrorDetails || (ImportAssetFromSignedUrlJobErrorDetails = {}));
export var Details;
(function (Details) {
    Details.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Details || (Details = {}));
export var JobErrorLimitName;
(function (JobErrorLimitName) {
    JobErrorLimitName["Amazon_Redshift_datashare_assets_per_revision"] = "Amazon Redshift datashare assets per revision";
    JobErrorLimitName["Asset_size_in_GB"] = "Asset size in GB";
    JobErrorLimitName["Assets_per_revision"] = "Assets per revision";
})(JobErrorLimitName || (JobErrorLimitName = {}));
export var JobErrorResourceTypes;
(function (JobErrorResourceTypes) {
    JobErrorResourceTypes["ASSET"] = "ASSET";
    JobErrorResourceTypes["DATA_SET"] = "DATA_SET";
    JobErrorResourceTypes["REVISION"] = "REVISION";
})(JobErrorResourceTypes || (JobErrorResourceTypes = {}));
export var JobError;
(function (JobError) {
    JobError.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(JobError || (JobError = {}));
export var State;
(function (State) {
    State["CANCELLED"] = "CANCELLED";
    State["COMPLETED"] = "COMPLETED";
    State["ERROR"] = "ERROR";
    State["IN_PROGRESS"] = "IN_PROGRESS";
    State["TIMED_OUT"] = "TIMED_OUT";
    State["WAITING"] = "WAITING";
})(State || (State = {}));
export var CreateJobResponse;
(function (CreateJobResponse) {
    CreateJobResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateJobResponse || (CreateJobResponse = {}));
export var CreateRevisionRequest;
(function (CreateRevisionRequest) {
    CreateRevisionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateRevisionRequest || (CreateRevisionRequest = {}));
export var CreateRevisionResponse;
(function (CreateRevisionResponse) {
    CreateRevisionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateRevisionResponse || (CreateRevisionResponse = {}));
export var DeleteAssetRequest;
(function (DeleteAssetRequest) {
    DeleteAssetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteAssetRequest || (DeleteAssetRequest = {}));
export var DeleteDataSetRequest;
(function (DeleteDataSetRequest) {
    DeleteDataSetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteDataSetRequest || (DeleteDataSetRequest = {}));
export var DeleteEventActionRequest;
(function (DeleteEventActionRequest) {
    DeleteEventActionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteEventActionRequest || (DeleteEventActionRequest = {}));
export var DeleteRevisionRequest;
(function (DeleteRevisionRequest) {
    DeleteRevisionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteRevisionRequest || (DeleteRevisionRequest = {}));
export var GetAssetRequest;
(function (GetAssetRequest) {
    GetAssetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetAssetRequest || (GetAssetRequest = {}));
export var GetAssetResponse;
(function (GetAssetResponse) {
    GetAssetResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetAssetResponse || (GetAssetResponse = {}));
export var GetDataSetRequest;
(function (GetDataSetRequest) {
    GetDataSetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetDataSetRequest || (GetDataSetRequest = {}));
export var GetDataSetResponse;
(function (GetDataSetResponse) {
    GetDataSetResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetDataSetResponse || (GetDataSetResponse = {}));
export var GetEventActionRequest;
(function (GetEventActionRequest) {
    GetEventActionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetEventActionRequest || (GetEventActionRequest = {}));
export var GetEventActionResponse;
(function (GetEventActionResponse) {
    GetEventActionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetEventActionResponse || (GetEventActionResponse = {}));
export var GetJobRequest;
(function (GetJobRequest) {
    GetJobRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetJobRequest || (GetJobRequest = {}));
export var GetJobResponse;
(function (GetJobResponse) {
    GetJobResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetJobResponse || (GetJobResponse = {}));
export var GetRevisionRequest;
(function (GetRevisionRequest) {
    GetRevisionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetRevisionRequest || (GetRevisionRequest = {}));
export var GetRevisionResponse;
(function (GetRevisionResponse) {
    GetRevisionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(GetRevisionResponse || (GetRevisionResponse = {}));
export var ListDataSetRevisionsRequest;
(function (ListDataSetRevisionsRequest) {
    ListDataSetRevisionsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListDataSetRevisionsRequest || (ListDataSetRevisionsRequest = {}));
export var RevisionEntry;
(function (RevisionEntry) {
    RevisionEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RevisionEntry || (RevisionEntry = {}));
export var ListDataSetRevisionsResponse;
(function (ListDataSetRevisionsResponse) {
    ListDataSetRevisionsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListDataSetRevisionsResponse || (ListDataSetRevisionsResponse = {}));
export var ListDataSetsRequest;
(function (ListDataSetsRequest) {
    ListDataSetsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListDataSetsRequest || (ListDataSetsRequest = {}));
export var DataSetEntry;
(function (DataSetEntry) {
    DataSetEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DataSetEntry || (DataSetEntry = {}));
export var ListDataSetsResponse;
(function (ListDataSetsResponse) {
    ListDataSetsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListDataSetsResponse || (ListDataSetsResponse = {}));
export var ListEventActionsRequest;
(function (ListEventActionsRequest) {
    ListEventActionsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEventActionsRequest || (ListEventActionsRequest = {}));
export var EventActionEntry;
(function (EventActionEntry) {
    EventActionEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(EventActionEntry || (EventActionEntry = {}));
export var ListEventActionsResponse;
(function (ListEventActionsResponse) {
    ListEventActionsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListEventActionsResponse || (ListEventActionsResponse = {}));
export var ListJobsRequest;
(function (ListJobsRequest) {
    ListJobsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListJobsRequest || (ListJobsRequest = {}));
export var JobEntry;
(function (JobEntry) {
    JobEntry.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(JobEntry || (JobEntry = {}));
export var ListJobsResponse;
(function (ListJobsResponse) {
    ListJobsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListJobsResponse || (ListJobsResponse = {}));
export var ListRevisionAssetsRequest;
(function (ListRevisionAssetsRequest) {
    ListRevisionAssetsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRevisionAssetsRequest || (ListRevisionAssetsRequest = {}));
export var ListRevisionAssetsResponse;
(function (ListRevisionAssetsResponse) {
    ListRevisionAssetsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListRevisionAssetsResponse || (ListRevisionAssetsResponse = {}));
export var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceRequest || (ListTagsForResourceRequest = {}));
export var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceResponse || (ListTagsForResourceResponse = {}));
export var RevokeRevisionRequest;
(function (RevokeRevisionRequest) {
    RevokeRevisionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RevokeRevisionRequest || (RevokeRevisionRequest = {}));
export var RevokeRevisionResponse;
(function (RevokeRevisionResponse) {
    RevokeRevisionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(RevokeRevisionResponse || (RevokeRevisionResponse = {}));
export var SendApiAssetRequest;
(function (SendApiAssetRequest) {
    SendApiAssetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SendApiAssetRequest || (SendApiAssetRequest = {}));
export var SendApiAssetResponse;
(function (SendApiAssetResponse) {
    SendApiAssetResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SendApiAssetResponse || (SendApiAssetResponse = {}));
export var StartJobRequest;
(function (StartJobRequest) {
    StartJobRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(StartJobRequest || (StartJobRequest = {}));
export var StartJobResponse;
(function (StartJobResponse) {
    StartJobResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(StartJobResponse || (StartJobResponse = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UpdateAssetRequest;
(function (UpdateAssetRequest) {
    UpdateAssetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateAssetRequest || (UpdateAssetRequest = {}));
export var UpdateAssetResponse;
(function (UpdateAssetResponse) {
    UpdateAssetResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateAssetResponse || (UpdateAssetResponse = {}));
export var UpdateDataSetRequest;
(function (UpdateDataSetRequest) {
    UpdateDataSetRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateDataSetRequest || (UpdateDataSetRequest = {}));
export var UpdateDataSetResponse;
(function (UpdateDataSetResponse) {
    UpdateDataSetResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateDataSetResponse || (UpdateDataSetResponse = {}));
export var UpdateEventActionRequest;
(function (UpdateEventActionRequest) {
    UpdateEventActionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateEventActionRequest || (UpdateEventActionRequest = {}));
export var UpdateEventActionResponse;
(function (UpdateEventActionResponse) {
    UpdateEventActionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateEventActionResponse || (UpdateEventActionResponse = {}));
export var UpdateRevisionRequest;
(function (UpdateRevisionRequest) {
    UpdateRevisionRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateRevisionRequest || (UpdateRevisionRequest = {}));
export var UpdateRevisionResponse;
(function (UpdateRevisionResponse) {
    UpdateRevisionResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateRevisionResponse || (UpdateRevisionResponse = {}));
