import { __assign, __awaiter, __generator, __read } from "tslib";
import { HttpRequest as __HttpRequest, isValidHostname as __isValidHostname, } from "@aws-sdk/protocol-http";
import { decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectNonNull as __expectNonNull, expectObject as __expectObject, expectString as __expectString, extendedEncodeURIComponent as __extendedEncodeURIComponent, limitedParseDouble as __limitedParseDouble, parseRfc3339DateTime as __parseRfc3339DateTime, } from "@aws-sdk/smithy-client";
import { DataExchangeServiceException as __BaseException } from "../models/DataExchangeServiceException";
import { AccessDeniedException, ConflictException, InternalServerException, ResourceNotFoundException, ServiceLimitExceededException, ThrottlingException, ValidationException, } from "../models/models_0";
export var serializeAws_restJson1CancelJobCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/jobs/{JobId}";
                if (input.JobId !== undefined) {
                    labelValue = input.JobId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: JobId.");
                    }
                    resolvedPath = resolvedPath.replace("{JobId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: JobId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "DELETE",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1CreateDataSetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets";
                body = JSON.stringify(__assign(__assign(__assign(__assign({}, (input.AssetType !== undefined && input.AssetType !== null && { AssetType: input.AssetType })), (input.Description !== undefined && input.Description !== null && { Description: input.Description })), (input.Name !== undefined && input.Name !== null && { Name: input.Name })), (input.Tags !== undefined &&
                    input.Tags !== null && { Tags: serializeAws_restJson1MapOf__string(input.Tags, context) })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1CreateEventActionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/event-actions";
                body = JSON.stringify(__assign(__assign({}, (input.Action !== undefined &&
                    input.Action !== null && { Action: serializeAws_restJson1Action(input.Action, context) })), (input.Event !== undefined &&
                    input.Event !== null && { Event: serializeAws_restJson1Event(input.Event, context) })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1CreateJobCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/jobs";
                body = JSON.stringify(__assign(__assign({}, (input.Details !== undefined &&
                    input.Details !== null && { Details: serializeAws_restJson1RequestDetails(input.Details, context) })), (input.Type !== undefined && input.Type !== null && { Type: input.Type })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1CreateRevisionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets/{DataSetId}/revisions";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                body = JSON.stringify(__assign(__assign({}, (input.Comment !== undefined && input.Comment !== null && { Comment: input.Comment })), (input.Tags !== undefined &&
                    input.Tags !== null && { Tags: serializeAws_restJson1MapOf__string(input.Tags, context) })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1DeleteAssetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}";
                if (input.AssetId !== undefined) {
                    labelValue = input.AssetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: AssetId.");
                    }
                    resolvedPath = resolvedPath.replace("{AssetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: AssetId.");
                }
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "DELETE",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1DeleteDataSetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets/{DataSetId}";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "DELETE",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1DeleteEventActionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/event-actions/{EventActionId}";
                if (input.EventActionId !== undefined) {
                    labelValue = input.EventActionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: EventActionId.");
                    }
                    resolvedPath = resolvedPath.replace("{EventActionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: EventActionId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "DELETE",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1DeleteRevisionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "DELETE",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1GetAssetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}";
                if (input.AssetId !== undefined) {
                    labelValue = input.AssetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: AssetId.");
                    }
                    resolvedPath = resolvedPath.replace("{AssetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: AssetId.");
                }
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1GetDataSetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets/{DataSetId}";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1GetEventActionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/event-actions/{EventActionId}";
                if (input.EventActionId !== undefined) {
                    labelValue = input.EventActionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: EventActionId.");
                    }
                    resolvedPath = resolvedPath.replace("{EventActionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: EventActionId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1GetJobCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/jobs/{JobId}";
                if (input.JobId !== undefined) {
                    labelValue = input.JobId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: JobId.");
                    }
                    resolvedPath = resolvedPath.replace("{JobId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: JobId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1GetRevisionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListDataSetRevisionsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets/{DataSetId}/revisions";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                query = __assign(__assign({}, (input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() })), (input.NextToken !== undefined && { nextToken: input.NextToken }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListDataSetsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets";
                query = __assign(__assign(__assign({}, (input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() })), (input.NextToken !== undefined && { nextToken: input.NextToken })), (input.Origin !== undefined && { origin: input.Origin }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListEventActionsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/event-actions";
                query = __assign(__assign(__assign({}, (input.EventSourceId !== undefined && { eventSourceId: input.EventSourceId })), (input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() })), (input.NextToken !== undefined && { nextToken: input.NextToken }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListJobsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/jobs";
                query = __assign(__assign(__assign(__assign({}, (input.DataSetId !== undefined && { dataSetId: input.DataSetId })), (input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() })), (input.NextToken !== undefined && { nextToken: input.NextToken })), (input.RevisionId !== undefined && { revisionId: input.RevisionId }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListRevisionAssetsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                query = __assign(__assign({}, (input.MaxResults !== undefined && { maxResults: input.MaxResults.toString() })), (input.NextToken !== undefined && { nextToken: input.NextToken }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListTagsForResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/tags/{ResourceArn}";
                if (input.ResourceArn !== undefined) {
                    labelValue = input.ResourceArn;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: ResourceArn.");
                    }
                    resolvedPath = resolvedPath.replace("{ResourceArn}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: ResourceArn.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1RevokeRevisionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/revoke";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                body = JSON.stringify(__assign({}, (input.RevocationComment !== undefined &&
                    input.RevocationComment !== null && { RevocationComment: input.RevocationComment })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1SendApiAssetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, query, body, resolvedHostname;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = __assign(__assign(__assign(__assign(__assign(__assign({ "content-type": "text/plain" }, (isSerializableHeaderValue(input.AssetId) && { "x-amzn-dataexchange-asset-id": input.AssetId })), (isSerializableHeaderValue(input.DataSetId) && { "x-amzn-dataexchange-data-set-id": input.DataSetId })), (isSerializableHeaderValue(input.Method) && { "x-amzn-dataexchange-http-method": input.Method })), (isSerializableHeaderValue(input.Path) && { "x-amzn-dataexchange-path": input.Path })), (isSerializableHeaderValue(input.RevisionId) && { "x-amzn-dataexchange-revision-id": input.RevisionId })), (input.RequestHeaders !== undefined &&
                    Object.keys(input.RequestHeaders).reduce(function (acc, suffix) {
                        var _a;
                        return (__assign(__assign({}, acc), (_a = {}, _a["x-amzn-dataexchange-header-".concat(suffix.toLowerCase())] = input.RequestHeaders[suffix], _a)));
                    }, {})));
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1";
                query = __assign({}, (input.QueryStringParameters !== undefined && input.QueryStringParameters));
                if (input.Body !== undefined) {
                    body = input.Body;
                }
                return [4, context.endpoint()];
            case 2:
                resolvedHostname = (_c.sent()).hostname;
                if (context.disableHostPrefix !== true) {
                    resolvedHostname = "api-fulfill." + resolvedHostname;
                    if (!__isValidHostname(resolvedHostname)) {
                        throw new Error("ValidationError: prefixed hostname must be hostname compatible.");
                    }
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: resolvedHostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1StartJobCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/jobs/{JobId}";
                if (input.JobId !== undefined) {
                    labelValue = input.JobId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: JobId.");
                    }
                    resolvedPath = resolvedPath.replace("{JobId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: JobId.");
                }
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "PATCH",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1TagResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/tags/{ResourceArn}";
                if (input.ResourceArn !== undefined) {
                    labelValue = input.ResourceArn;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: ResourceArn.");
                    }
                    resolvedPath = resolvedPath.replace("{ResourceArn}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: ResourceArn.");
                }
                body = JSON.stringify(__assign({}, (input.Tags !== undefined &&
                    input.Tags !== null && { tags: serializeAws_restJson1MapOf__string(input.Tags, context) })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1UntagResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/tags/{ResourceArn}";
                if (input.ResourceArn !== undefined) {
                    labelValue = input.ResourceArn;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: ResourceArn.");
                    }
                    resolvedPath = resolvedPath.replace("{ResourceArn}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: ResourceArn.");
                }
                query = __assign({}, (input.TagKeys !== undefined && { tagKeys: (input.TagKeys || []).map(function (_entry) { return _entry; }) }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "DELETE",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1UpdateAssetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}";
                if (input.AssetId !== undefined) {
                    labelValue = input.AssetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: AssetId.");
                    }
                    resolvedPath = resolvedPath.replace("{AssetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: AssetId.");
                }
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                body = JSON.stringify(__assign({}, (input.Name !== undefined && input.Name !== null && { Name: input.Name })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "PATCH",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1UpdateDataSetCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/data-sets/{DataSetId}";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                body = JSON.stringify(__assign(__assign({}, (input.Description !== undefined && input.Description !== null && { Description: input.Description })), (input.Name !== undefined && input.Name !== null && { Name: input.Name })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "PATCH",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1UpdateEventActionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/v1/event-actions/{EventActionId}";
                if (input.EventActionId !== undefined) {
                    labelValue = input.EventActionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: EventActionId.");
                    }
                    resolvedPath = resolvedPath.replace("{EventActionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: EventActionId.");
                }
                body = JSON.stringify(__assign({}, (input.Action !== undefined &&
                    input.Action !== null && { Action: serializeAws_restJson1Action(input.Action, context) })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "PATCH",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1UpdateRevisionCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, labelValue, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") +
                    "/v1/data-sets/{DataSetId}/revisions/{RevisionId}";
                if (input.DataSetId !== undefined) {
                    labelValue = input.DataSetId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: DataSetId.");
                    }
                    resolvedPath = resolvedPath.replace("{DataSetId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: DataSetId.");
                }
                if (input.RevisionId !== undefined) {
                    labelValue = input.RevisionId;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: RevisionId.");
                    }
                    resolvedPath = resolvedPath.replace("{RevisionId}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: RevisionId.");
                }
                body = JSON.stringify(__assign(__assign({}, (input.Comment !== undefined && input.Comment !== null && { Comment: input.Comment })), (input.Finalized !== undefined && input.Finalized !== null && { Finalized: input.Finalized })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "PATCH",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var deserializeAws_restJson1CancelJobCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1CancelJobCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1CancelJobCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "ConflictException": return [3, 2];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1CreateDataSetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 201 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1CreateDataSetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    AssetType: undefined,
                    CreatedAt: undefined,
                    Description: undefined,
                    Id: undefined,
                    Name: undefined,
                    Origin: undefined,
                    OriginDetails: undefined,
                    SourceId: undefined,
                    Tags: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.AssetType !== undefined && data.AssetType !== null) {
                    contents.AssetType = __expectString(data.AssetType);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Description !== undefined && data.Description !== null) {
                    contents.Description = __expectString(data.Description);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.Name !== undefined && data.Name !== null) {
                    contents.Name = __expectString(data.Name);
                }
                if (data.Origin !== undefined && data.Origin !== null) {
                    contents.Origin = __expectString(data.Origin);
                }
                if (data.OriginDetails !== undefined && data.OriginDetails !== null) {
                    contents.OriginDetails = deserializeAws_restJson1OriginDetails(data.OriginDetails, context);
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.Tags !== undefined && data.Tags !== null) {
                    contents.Tags = deserializeAws_restJson1MapOf__string(data.Tags, context);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1CreateDataSetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ServiceLimitExceededException": return [3, 6];
                    case "com.amazonaws.dataexchange#ServiceLimitExceededException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceLimitExceededExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1CreateEventActionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 201 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1CreateEventActionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Action: undefined,
                    Arn: undefined,
                    CreatedAt: undefined,
                    Event: undefined,
                    Id: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Action !== undefined && data.Action !== null) {
                    contents.Action = deserializeAws_restJson1Action(data.Action, context);
                }
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Event !== undefined && data.Event !== null) {
                    contents.Event = deserializeAws_restJson1Event(data.Event, context);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1CreateEventActionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ServiceLimitExceededException": return [3, 6];
                    case "com.amazonaws.dataexchange#ServiceLimitExceededException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceLimitExceededExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1CreateJobCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 201 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1CreateJobCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    CreatedAt: undefined,
                    Details: undefined,
                    Errors: undefined,
                    Id: undefined,
                    State: undefined,
                    Type: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Details !== undefined && data.Details !== null) {
                    contents.Details = deserializeAws_restJson1ResponseDetails(data.Details, context);
                }
                if (data.Errors !== undefined && data.Errors !== null) {
                    contents.Errors = deserializeAws_restJson1ListOfJobError(data.Errors, context);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.State !== undefined && data.State !== null) {
                    contents.State = __expectString(data.State);
                }
                if (data.Type !== undefined && data.Type !== null) {
                    contents.Type = __expectString(data.Type);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1CreateJobCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1CreateRevisionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 201 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1CreateRevisionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    Comment: undefined,
                    CreatedAt: undefined,
                    DataSetId: undefined,
                    Finalized: undefined,
                    Id: undefined,
                    RevocationComment: undefined,
                    Revoked: undefined,
                    RevokedAt: undefined,
                    SourceId: undefined,
                    Tags: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.Comment !== undefined && data.Comment !== null) {
                    contents.Comment = __expectString(data.Comment);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.DataSetId !== undefined && data.DataSetId !== null) {
                    contents.DataSetId = __expectString(data.DataSetId);
                }
                if (data.Finalized !== undefined && data.Finalized !== null) {
                    contents.Finalized = __expectBoolean(data.Finalized);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.RevocationComment !== undefined && data.RevocationComment !== null) {
                    contents.RevocationComment = __expectString(data.RevocationComment);
                }
                if (data.Revoked !== undefined && data.Revoked !== null) {
                    contents.Revoked = __expectBoolean(data.Revoked);
                }
                if (data.RevokedAt !== undefined && data.RevokedAt !== null) {
                    contents.RevokedAt = __expectNonNull(__parseRfc3339DateTime(data.RevokedAt));
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.Tags !== undefined && data.Tags !== null) {
                    contents.Tags = deserializeAws_restJson1MapOf__string(data.Tags, context);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1CreateRevisionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1DeleteAssetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1DeleteAssetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1DeleteAssetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1DeleteDataSetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1DeleteDataSetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1DeleteDataSetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1DeleteEventActionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1DeleteEventActionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1DeleteEventActionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1DeleteRevisionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1DeleteRevisionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1DeleteRevisionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1GetAssetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1GetAssetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    AssetDetails: undefined,
                    AssetType: undefined,
                    CreatedAt: undefined,
                    DataSetId: undefined,
                    Id: undefined,
                    Name: undefined,
                    RevisionId: undefined,
                    SourceId: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.AssetDetails !== undefined && data.AssetDetails !== null) {
                    contents.AssetDetails = deserializeAws_restJson1AssetDetails(data.AssetDetails, context);
                }
                if (data.AssetType !== undefined && data.AssetType !== null) {
                    contents.AssetType = __expectString(data.AssetType);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.DataSetId !== undefined && data.DataSetId !== null) {
                    contents.DataSetId = __expectString(data.DataSetId);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.Name !== undefined && data.Name !== null) {
                    contents.Name = __expectString(data.Name);
                }
                if (data.RevisionId !== undefined && data.RevisionId !== null) {
                    contents.RevisionId = __expectString(data.RevisionId);
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1GetAssetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1GetDataSetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1GetDataSetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    AssetType: undefined,
                    CreatedAt: undefined,
                    Description: undefined,
                    Id: undefined,
                    Name: undefined,
                    Origin: undefined,
                    OriginDetails: undefined,
                    SourceId: undefined,
                    Tags: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.AssetType !== undefined && data.AssetType !== null) {
                    contents.AssetType = __expectString(data.AssetType);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Description !== undefined && data.Description !== null) {
                    contents.Description = __expectString(data.Description);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.Name !== undefined && data.Name !== null) {
                    contents.Name = __expectString(data.Name);
                }
                if (data.Origin !== undefined && data.Origin !== null) {
                    contents.Origin = __expectString(data.Origin);
                }
                if (data.OriginDetails !== undefined && data.OriginDetails !== null) {
                    contents.OriginDetails = deserializeAws_restJson1OriginDetails(data.OriginDetails, context);
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.Tags !== undefined && data.Tags !== null) {
                    contents.Tags = deserializeAws_restJson1MapOf__string(data.Tags, context);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1GetDataSetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1GetEventActionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1GetEventActionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Action: undefined,
                    Arn: undefined,
                    CreatedAt: undefined,
                    Event: undefined,
                    Id: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Action !== undefined && data.Action !== null) {
                    contents.Action = deserializeAws_restJson1Action(data.Action, context);
                }
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Event !== undefined && data.Event !== null) {
                    contents.Event = deserializeAws_restJson1Event(data.Event, context);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1GetEventActionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1GetJobCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1GetJobCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    CreatedAt: undefined,
                    Details: undefined,
                    Errors: undefined,
                    Id: undefined,
                    State: undefined,
                    Type: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Details !== undefined && data.Details !== null) {
                    contents.Details = deserializeAws_restJson1ResponseDetails(data.Details, context);
                }
                if (data.Errors !== undefined && data.Errors !== null) {
                    contents.Errors = deserializeAws_restJson1ListOfJobError(data.Errors, context);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.State !== undefined && data.State !== null) {
                    contents.State = __expectString(data.State);
                }
                if (data.Type !== undefined && data.Type !== null) {
                    contents.Type = __expectString(data.Type);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1GetJobCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1GetRevisionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1GetRevisionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    Comment: undefined,
                    CreatedAt: undefined,
                    DataSetId: undefined,
                    Finalized: undefined,
                    Id: undefined,
                    RevocationComment: undefined,
                    Revoked: undefined,
                    RevokedAt: undefined,
                    SourceId: undefined,
                    Tags: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.Comment !== undefined && data.Comment !== null) {
                    contents.Comment = __expectString(data.Comment);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.DataSetId !== undefined && data.DataSetId !== null) {
                    contents.DataSetId = __expectString(data.DataSetId);
                }
                if (data.Finalized !== undefined && data.Finalized !== null) {
                    contents.Finalized = __expectBoolean(data.Finalized);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.RevocationComment !== undefined && data.RevocationComment !== null) {
                    contents.RevocationComment = __expectString(data.RevocationComment);
                }
                if (data.Revoked !== undefined && data.Revoked !== null) {
                    contents.Revoked = __expectBoolean(data.Revoked);
                }
                if (data.RevokedAt !== undefined && data.RevokedAt !== null) {
                    contents.RevokedAt = __expectNonNull(__parseRfc3339DateTime(data.RevokedAt));
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.Tags !== undefined && data.Tags !== null) {
                    contents.Tags = deserializeAws_restJson1MapOf__string(data.Tags, context);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1GetRevisionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListDataSetRevisionsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListDataSetRevisionsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    NextToken: undefined,
                    Revisions: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.NextToken !== undefined && data.NextToken !== null) {
                    contents.NextToken = __expectString(data.NextToken);
                }
                if (data.Revisions !== undefined && data.Revisions !== null) {
                    contents.Revisions = deserializeAws_restJson1ListOfRevisionEntry(data.Revisions, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListDataSetRevisionsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListDataSetsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListDataSetsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    DataSets: undefined,
                    NextToken: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.DataSets !== undefined && data.DataSets !== null) {
                    contents.DataSets = deserializeAws_restJson1ListOfDataSetEntry(data.DataSets, context);
                }
                if (data.NextToken !== undefined && data.NextToken !== null) {
                    contents.NextToken = __expectString(data.NextToken);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListDataSetsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListEventActionsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListEventActionsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    EventActions: undefined,
                    NextToken: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.EventActions !== undefined && data.EventActions !== null) {
                    contents.EventActions = deserializeAws_restJson1ListOfEventActionEntry(data.EventActions, context);
                }
                if (data.NextToken !== undefined && data.NextToken !== null) {
                    contents.NextToken = __expectString(data.NextToken);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListEventActionsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListJobsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListJobsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Jobs: undefined,
                    NextToken: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Jobs !== undefined && data.Jobs !== null) {
                    contents.Jobs = deserializeAws_restJson1ListOfJobEntry(data.Jobs, context);
                }
                if (data.NextToken !== undefined && data.NextToken !== null) {
                    contents.NextToken = __expectString(data.NextToken);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListJobsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListRevisionAssetsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListRevisionAssetsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Assets: undefined,
                    NextToken: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Assets !== undefined && data.Assets !== null) {
                    contents.Assets = deserializeAws_restJson1ListOfAssetEntry(data.Assets, context);
                }
                if (data.NextToken !== undefined && data.NextToken !== null) {
                    contents.NextToken = __expectString(data.NextToken);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListRevisionAssetsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListTagsForResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListTagsForResourceCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Tags: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.tags !== undefined && data.tags !== null) {
                    contents.Tags = deserializeAws_restJson1MapOf__string(data.tags, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListTagsForResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, parsedBody;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = [__assign({}, output)];
                _b = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_b.body = _c.sent(), _b)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                switch (errorCode) {
                    default:
                        parsedBody = parsedOutput.body;
                        response = new __BaseException({
                            name: parsedBody.code || parsedBody.Code || errorCode,
                            $fault: "client",
                            $metadata: deserializeMetadata(output),
                        });
                        throw __decorateServiceException(response, parsedBody);
                }
                return [2];
        }
    });
}); };
export var deserializeAws_restJson1RevokeRevisionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1RevokeRevisionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    Comment: undefined,
                    CreatedAt: undefined,
                    DataSetId: undefined,
                    Finalized: undefined,
                    Id: undefined,
                    RevocationComment: undefined,
                    Revoked: undefined,
                    RevokedAt: undefined,
                    SourceId: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.Comment !== undefined && data.Comment !== null) {
                    contents.Comment = __expectString(data.Comment);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.DataSetId !== undefined && data.DataSetId !== null) {
                    contents.DataSetId = __expectString(data.DataSetId);
                }
                if (data.Finalized !== undefined && data.Finalized !== null) {
                    contents.Finalized = __expectBoolean(data.Finalized);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.RevocationComment !== undefined && data.RevocationComment !== null) {
                    contents.RevocationComment = __expectString(data.RevocationComment);
                }
                if (data.Revoked !== undefined && data.Revoked !== null) {
                    contents.Revoked = __expectBoolean(data.Revoked);
                }
                if (data.RevokedAt !== undefined && data.RevokedAt !== null) {
                    contents.RevokedAt = __expectNonNull(__parseRfc3339DateTime(data.RevokedAt));
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1RevokeRevisionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1SendApiAssetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1SendApiAssetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Body: undefined,
                    ResponseHeaders: undefined,
                };
                Object.keys(output.headers).forEach(function (header) {
                    if (contents.ResponseHeaders === undefined) {
                        contents.ResponseHeaders = {};
                    }
                    if (header.startsWith("")) {
                        contents.ResponseHeaders[header.substring(0)] = output.headers[header];
                    }
                });
                return [4, collectBodyString(output.body, context)];
            case 1:
                data = _a.sent();
                contents.Body = __expectString(data);
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1SendApiAssetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1StartJobCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 202 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1StartJobCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1StartJobCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1TagResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1TagResourceCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1TagResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, parsedBody;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = [__assign({}, output)];
                _b = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_b.body = _c.sent(), _b)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                switch (errorCode) {
                    default:
                        parsedBody = parsedOutput.body;
                        response = new __BaseException({
                            name: parsedBody.code || parsedBody.Code || errorCode,
                            $fault: "client",
                            $metadata: deserializeMetadata(output),
                        });
                        throw __decorateServiceException(response, parsedBody);
                }
                return [2];
        }
    });
}); };
export var deserializeAws_restJson1UntagResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode !== 204 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1UntagResourceCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                };
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1UntagResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, parsedBody;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                _a = [__assign({}, output)];
                _b = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_b.body = _c.sent(), _b)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                switch (errorCode) {
                    default:
                        parsedBody = parsedOutput.body;
                        response = new __BaseException({
                            name: parsedBody.code || parsedBody.Code || errorCode,
                            $fault: "client",
                            $metadata: deserializeMetadata(output),
                        });
                        throw __decorateServiceException(response, parsedBody);
                }
                return [2];
        }
    });
}); };
export var deserializeAws_restJson1UpdateAssetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1UpdateAssetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    AssetDetails: undefined,
                    AssetType: undefined,
                    CreatedAt: undefined,
                    DataSetId: undefined,
                    Id: undefined,
                    Name: undefined,
                    RevisionId: undefined,
                    SourceId: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.AssetDetails !== undefined && data.AssetDetails !== null) {
                    contents.AssetDetails = deserializeAws_restJson1AssetDetails(data.AssetDetails, context);
                }
                if (data.AssetType !== undefined && data.AssetType !== null) {
                    contents.AssetType = __expectString(data.AssetType);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.DataSetId !== undefined && data.DataSetId !== null) {
                    contents.DataSetId = __expectString(data.DataSetId);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.Name !== undefined && data.Name !== null) {
                    contents.Name = __expectString(data.Name);
                }
                if (data.RevisionId !== undefined && data.RevisionId !== null) {
                    contents.RevisionId = __expectString(data.RevisionId);
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1UpdateAssetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1UpdateDataSetCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1UpdateDataSetCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    AssetType: undefined,
                    CreatedAt: undefined,
                    Description: undefined,
                    Id: undefined,
                    Name: undefined,
                    Origin: undefined,
                    OriginDetails: undefined,
                    SourceId: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.AssetType !== undefined && data.AssetType !== null) {
                    contents.AssetType = __expectString(data.AssetType);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Description !== undefined && data.Description !== null) {
                    contents.Description = __expectString(data.Description);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.Name !== undefined && data.Name !== null) {
                    contents.Name = __expectString(data.Name);
                }
                if (data.Origin !== undefined && data.Origin !== null) {
                    contents.Origin = __expectString(data.Origin);
                }
                if (data.OriginDetails !== undefined && data.OriginDetails !== null) {
                    contents.OriginDetails = deserializeAws_restJson1OriginDetails(data.OriginDetails, context);
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1UpdateDataSetCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1UpdateEventActionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1UpdateEventActionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Action: undefined,
                    Arn: undefined,
                    CreatedAt: undefined,
                    Event: undefined,
                    Id: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Action !== undefined && data.Action !== null) {
                    contents.Action = deserializeAws_restJson1Action(data.Action, context);
                }
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.Event !== undefined && data.Event !== null) {
                    contents.Event = deserializeAws_restJson1Event(data.Event, context);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1UpdateEventActionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1UpdateRevisionCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1UpdateRevisionCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    Arn: undefined,
                    Comment: undefined,
                    CreatedAt: undefined,
                    DataSetId: undefined,
                    Finalized: undefined,
                    Id: undefined,
                    RevocationComment: undefined,
                    Revoked: undefined,
                    RevokedAt: undefined,
                    SourceId: undefined,
                    UpdatedAt: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.Arn !== undefined && data.Arn !== null) {
                    contents.Arn = __expectString(data.Arn);
                }
                if (data.Comment !== undefined && data.Comment !== null) {
                    contents.Comment = __expectString(data.Comment);
                }
                if (data.CreatedAt !== undefined && data.CreatedAt !== null) {
                    contents.CreatedAt = __expectNonNull(__parseRfc3339DateTime(data.CreatedAt));
                }
                if (data.DataSetId !== undefined && data.DataSetId !== null) {
                    contents.DataSetId = __expectString(data.DataSetId);
                }
                if (data.Finalized !== undefined && data.Finalized !== null) {
                    contents.Finalized = __expectBoolean(data.Finalized);
                }
                if (data.Id !== undefined && data.Id !== null) {
                    contents.Id = __expectString(data.Id);
                }
                if (data.RevocationComment !== undefined && data.RevocationComment !== null) {
                    contents.RevocationComment = __expectString(data.RevocationComment);
                }
                if (data.Revoked !== undefined && data.Revoked !== null) {
                    contents.Revoked = __expectBoolean(data.Revoked);
                }
                if (data.RevokedAt !== undefined && data.RevokedAt !== null) {
                    contents.RevokedAt = __expectNonNull(__parseRfc3339DateTime(data.RevokedAt));
                }
                if (data.SourceId !== undefined && data.SourceId !== null) {
                    contents.SourceId = __expectString(data.SourceId);
                }
                if (data.UpdatedAt !== undefined && data.UpdatedAt !== null) {
                    contents.UpdatedAt = __expectNonNull(__parseRfc3339DateTime(data.UpdatedAt));
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1UpdateRevisionCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.dataexchange#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.dataexchange#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.dataexchange#InternalServerException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.dataexchange#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.dataexchange#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.dataexchange#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_restJson1AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_restJson1ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
var deserializeAws_restJson1AccessDeniedExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        exception = new AccessDeniedException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ConflictExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        if (data.ResourceId !== undefined && data.ResourceId !== null) {
            contents.ResourceId = __expectString(data.ResourceId);
        }
        if (data.ResourceType !== undefined && data.ResourceType !== null) {
            contents.ResourceType = __expectString(data.ResourceType);
        }
        exception = new ConflictException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1InternalServerExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        exception = new InternalServerException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ResourceNotFoundExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        if (data.ResourceId !== undefined && data.ResourceId !== null) {
            contents.ResourceId = __expectString(data.ResourceId);
        }
        if (data.ResourceType !== undefined && data.ResourceType !== null) {
            contents.ResourceType = __expectString(data.ResourceType);
        }
        exception = new ResourceNotFoundException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ServiceLimitExceededExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.LimitName !== undefined && data.LimitName !== null) {
            contents.LimitName = __expectString(data.LimitName);
        }
        if (data.LimitValue !== undefined && data.LimitValue !== null) {
            contents.LimitValue = __limitedParseDouble(data.LimitValue);
        }
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        exception = new ServiceLimitExceededException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ThrottlingExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        exception = new ThrottlingException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ValidationExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.ExceptionCause !== undefined && data.ExceptionCause !== null) {
            contents.ExceptionCause = __expectString(data.ExceptionCause);
        }
        if (data.Message !== undefined && data.Message !== null) {
            contents.Message = __expectString(data.Message);
        }
        exception = new ValidationException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var serializeAws_restJson1Action = function (input, context) {
    return __assign({}, (input.ExportRevisionToS3 !== undefined &&
        input.ExportRevisionToS3 !== null && {
        ExportRevisionToS3: serializeAws_restJson1AutoExportRevisionToS3RequestDetails(input.ExportRevisionToS3, context),
    }));
};
var serializeAws_restJson1AssetDestinationEntry = function (input, context) {
    return __assign(__assign(__assign({}, (input.AssetId !== undefined && input.AssetId !== null && { AssetId: input.AssetId })), (input.Bucket !== undefined && input.Bucket !== null && { Bucket: input.Bucket })), (input.Key !== undefined && input.Key !== null && { Key: input.Key }));
};
var serializeAws_restJson1AssetSourceEntry = function (input, context) {
    return __assign(__assign({}, (input.Bucket !== undefined && input.Bucket !== null && { Bucket: input.Bucket })), (input.Key !== undefined && input.Key !== null && { Key: input.Key }));
};
var serializeAws_restJson1AutoExportRevisionDestinationEntry = function (input, context) {
    return __assign(__assign({}, (input.Bucket !== undefined && input.Bucket !== null && { Bucket: input.Bucket })), (input.KeyPattern !== undefined && input.KeyPattern !== null && { KeyPattern: input.KeyPattern }));
};
var serializeAws_restJson1AutoExportRevisionToS3RequestDetails = function (input, context) {
    return __assign(__assign({}, (input.Encryption !== undefined &&
        input.Encryption !== null && {
        Encryption: serializeAws_restJson1ExportServerSideEncryption(input.Encryption, context),
    })), (input.RevisionDestination !== undefined &&
        input.RevisionDestination !== null && {
        RevisionDestination: serializeAws_restJson1AutoExportRevisionDestinationEntry(input.RevisionDestination, context),
    }));
};
var serializeAws_restJson1Event = function (input, context) {
    return __assign({}, (input.RevisionPublished !== undefined &&
        input.RevisionPublished !== null && {
        RevisionPublished: serializeAws_restJson1RevisionPublished(input.RevisionPublished, context),
    }));
};
var serializeAws_restJson1ExportAssetsToS3RequestDetails = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.AssetDestinations !== undefined &&
        input.AssetDestinations !== null && {
        AssetDestinations: serializeAws_restJson1ListOfAssetDestinationEntry(input.AssetDestinations, context),
    })), (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.Encryption !== undefined &&
        input.Encryption !== null && {
        Encryption: serializeAws_restJson1ExportServerSideEncryption(input.Encryption, context),
    })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId }));
};
var serializeAws_restJson1ExportAssetToSignedUrlRequestDetails = function (input, context) {
    return __assign(__assign(__assign({}, (input.AssetId !== undefined && input.AssetId !== null && { AssetId: input.AssetId })), (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId }));
};
var serializeAws_restJson1ExportRevisionsToS3RequestDetails = function (input, context) {
    return __assign(__assign(__assign({}, (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.Encryption !== undefined &&
        input.Encryption !== null && {
        Encryption: serializeAws_restJson1ExportServerSideEncryption(input.Encryption, context),
    })), (input.RevisionDestinations !== undefined &&
        input.RevisionDestinations !== null && {
        RevisionDestinations: serializeAws_restJson1ListOfRevisionDestinationEntry(input.RevisionDestinations, context),
    }));
};
var serializeAws_restJson1ExportServerSideEncryption = function (input, context) {
    return __assign(__assign({}, (input.KmsKeyArn !== undefined && input.KmsKeyArn !== null && { KmsKeyArn: input.KmsKeyArn })), (input.Type !== undefined && input.Type !== null && { Type: input.Type }));
};
var serializeAws_restJson1ImportAssetFromApiGatewayApiRequestDetails = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.ApiDescription !== undefined &&
        input.ApiDescription !== null && { ApiDescription: input.ApiDescription })), (input.ApiId !== undefined && input.ApiId !== null && { ApiId: input.ApiId })), (input.ApiKey !== undefined && input.ApiKey !== null && { ApiKey: input.ApiKey })), (input.ApiName !== undefined && input.ApiName !== null && { ApiName: input.ApiName })), (input.ApiSpecificationMd5Hash !== undefined &&
        input.ApiSpecificationMd5Hash !== null && { ApiSpecificationMd5Hash: input.ApiSpecificationMd5Hash })), (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.ProtocolType !== undefined && input.ProtocolType !== null && { ProtocolType: input.ProtocolType })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId })), (input.Stage !== undefined && input.Stage !== null && { Stage: input.Stage }));
};
var serializeAws_restJson1ImportAssetFromSignedUrlRequestDetails = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.AssetName !== undefined && input.AssetName !== null && { AssetName: input.AssetName })), (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.Md5Hash !== undefined && input.Md5Hash !== null && { Md5Hash: input.Md5Hash })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId }));
};
var serializeAws_restJson1ImportAssetsFromRedshiftDataSharesRequestDetails = function (input, context) {
    return __assign(__assign(__assign({}, (input.AssetSources !== undefined &&
        input.AssetSources !== null && {
        AssetSources: serializeAws_restJson1ListOfRedshiftDataShareAssetSourceEntry(input.AssetSources, context),
    })), (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId }));
};
var serializeAws_restJson1ImportAssetsFromS3RequestDetails = function (input, context) {
    return __assign(__assign(__assign({}, (input.AssetSources !== undefined &&
        input.AssetSources !== null && {
        AssetSources: serializeAws_restJson1ListOfAssetSourceEntry(input.AssetSources, context),
    })), (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId }));
};
var serializeAws_restJson1ListOfAssetDestinationEntry = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1AssetDestinationEntry(entry, context);
    });
};
var serializeAws_restJson1ListOfAssetSourceEntry = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1AssetSourceEntry(entry, context);
    });
};
var serializeAws_restJson1ListOfRedshiftDataShareAssetSourceEntry = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1RedshiftDataShareAssetSourceEntry(entry, context);
    });
};
var serializeAws_restJson1ListOfRevisionDestinationEntry = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1RevisionDestinationEntry(entry, context);
    });
};
var serializeAws_restJson1MapOf__string = function (input, context) {
    return Object.entries(input).reduce(function (acc, _a) {
        var _b;
        var _c = __read(_a, 2), key = _c[0], value = _c[1];
        if (value === null) {
            return acc;
        }
        return __assign(__assign({}, acc), (_b = {}, _b[key] = value, _b));
    }, {});
};
var serializeAws_restJson1RedshiftDataShareAssetSourceEntry = function (input, context) {
    return __assign({}, (input.DataShareArn !== undefined && input.DataShareArn !== null && { DataShareArn: input.DataShareArn }));
};
var serializeAws_restJson1RequestDetails = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.ExportAssetToSignedUrl !== undefined &&
        input.ExportAssetToSignedUrl !== null && {
        ExportAssetToSignedUrl: serializeAws_restJson1ExportAssetToSignedUrlRequestDetails(input.ExportAssetToSignedUrl, context),
    })), (input.ExportAssetsToS3 !== undefined &&
        input.ExportAssetsToS3 !== null && {
        ExportAssetsToS3: serializeAws_restJson1ExportAssetsToS3RequestDetails(input.ExportAssetsToS3, context),
    })), (input.ExportRevisionsToS3 !== undefined &&
        input.ExportRevisionsToS3 !== null && {
        ExportRevisionsToS3: serializeAws_restJson1ExportRevisionsToS3RequestDetails(input.ExportRevisionsToS3, context),
    })), (input.ImportAssetFromApiGatewayApi !== undefined &&
        input.ImportAssetFromApiGatewayApi !== null && {
        ImportAssetFromApiGatewayApi: serializeAws_restJson1ImportAssetFromApiGatewayApiRequestDetails(input.ImportAssetFromApiGatewayApi, context),
    })), (input.ImportAssetFromSignedUrl !== undefined &&
        input.ImportAssetFromSignedUrl !== null && {
        ImportAssetFromSignedUrl: serializeAws_restJson1ImportAssetFromSignedUrlRequestDetails(input.ImportAssetFromSignedUrl, context),
    })), (input.ImportAssetsFromRedshiftDataShares !== undefined &&
        input.ImportAssetsFromRedshiftDataShares !== null && {
        ImportAssetsFromRedshiftDataShares: serializeAws_restJson1ImportAssetsFromRedshiftDataSharesRequestDetails(input.ImportAssetsFromRedshiftDataShares, context),
    })), (input.ImportAssetsFromS3 !== undefined &&
        input.ImportAssetsFromS3 !== null && {
        ImportAssetsFromS3: serializeAws_restJson1ImportAssetsFromS3RequestDetails(input.ImportAssetsFromS3, context),
    }));
};
var serializeAws_restJson1RevisionDestinationEntry = function (input, context) {
    return __assign(__assign(__assign({}, (input.Bucket !== undefined && input.Bucket !== null && { Bucket: input.Bucket })), (input.KeyPattern !== undefined && input.KeyPattern !== null && { KeyPattern: input.KeyPattern })), (input.RevisionId !== undefined && input.RevisionId !== null && { RevisionId: input.RevisionId }));
};
var serializeAws_restJson1RevisionPublished = function (input, context) {
    return __assign({}, (input.DataSetId !== undefined && input.DataSetId !== null && { DataSetId: input.DataSetId }));
};
var deserializeAws_restJson1Action = function (output, context) {
    return {
        ExportRevisionToS3: output.ExportRevisionToS3 !== undefined && output.ExportRevisionToS3 !== null
            ? deserializeAws_restJson1AutoExportRevisionToS3RequestDetails(output.ExportRevisionToS3, context)
            : undefined,
    };
};
var deserializeAws_restJson1ApiGatewayApiAsset = function (output, context) {
    return {
        ApiDescription: __expectString(output.ApiDescription),
        ApiEndpoint: __expectString(output.ApiEndpoint),
        ApiId: __expectString(output.ApiId),
        ApiKey: __expectString(output.ApiKey),
        ApiName: __expectString(output.ApiName),
        ApiSpecificationDownloadUrl: __expectString(output.ApiSpecificationDownloadUrl),
        ApiSpecificationDownloadUrlExpiresAt: output.ApiSpecificationDownloadUrlExpiresAt !== undefined && output.ApiSpecificationDownloadUrlExpiresAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.ApiSpecificationDownloadUrlExpiresAt))
            : undefined,
        ProtocolType: __expectString(output.ProtocolType),
        Stage: __expectString(output.Stage),
    };
};
var deserializeAws_restJson1AssetDestinationEntry = function (output, context) {
    return {
        AssetId: __expectString(output.AssetId),
        Bucket: __expectString(output.Bucket),
        Key: __expectString(output.Key),
    };
};
var deserializeAws_restJson1AssetDetails = function (output, context) {
    return {
        ApiGatewayApiAsset: output.ApiGatewayApiAsset !== undefined && output.ApiGatewayApiAsset !== null
            ? deserializeAws_restJson1ApiGatewayApiAsset(output.ApiGatewayApiAsset, context)
            : undefined,
        RedshiftDataShareAsset: output.RedshiftDataShareAsset !== undefined && output.RedshiftDataShareAsset !== null
            ? deserializeAws_restJson1RedshiftDataShareAsset(output.RedshiftDataShareAsset, context)
            : undefined,
        S3SnapshotAsset: output.S3SnapshotAsset !== undefined && output.S3SnapshotAsset !== null
            ? deserializeAws_restJson1S3SnapshotAsset(output.S3SnapshotAsset, context)
            : undefined,
    };
};
var deserializeAws_restJson1AssetEntry = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
        AssetDetails: output.AssetDetails !== undefined && output.AssetDetails !== null
            ? deserializeAws_restJson1AssetDetails(output.AssetDetails, context)
            : undefined,
        AssetType: __expectString(output.AssetType),
        CreatedAt: output.CreatedAt !== undefined && output.CreatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.CreatedAt))
            : undefined,
        DataSetId: __expectString(output.DataSetId),
        Id: __expectString(output.Id),
        Name: __expectString(output.Name),
        RevisionId: __expectString(output.RevisionId),
        SourceId: __expectString(output.SourceId),
        UpdatedAt: output.UpdatedAt !== undefined && output.UpdatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.UpdatedAt))
            : undefined,
    };
};
var deserializeAws_restJson1AssetSourceEntry = function (output, context) {
    return {
        Bucket: __expectString(output.Bucket),
        Key: __expectString(output.Key),
    };
};
var deserializeAws_restJson1AutoExportRevisionDestinationEntry = function (output, context) {
    return {
        Bucket: __expectString(output.Bucket),
        KeyPattern: __expectString(output.KeyPattern),
    };
};
var deserializeAws_restJson1AutoExportRevisionToS3RequestDetails = function (output, context) {
    return {
        Encryption: output.Encryption !== undefined && output.Encryption !== null
            ? deserializeAws_restJson1ExportServerSideEncryption(output.Encryption, context)
            : undefined,
        RevisionDestination: output.RevisionDestination !== undefined && output.RevisionDestination !== null
            ? deserializeAws_restJson1AutoExportRevisionDestinationEntry(output.RevisionDestination, context)
            : undefined,
    };
};
var deserializeAws_restJson1DataSetEntry = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
        AssetType: __expectString(output.AssetType),
        CreatedAt: output.CreatedAt !== undefined && output.CreatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.CreatedAt))
            : undefined,
        Description: __expectString(output.Description),
        Id: __expectString(output.Id),
        Name: __expectString(output.Name),
        Origin: __expectString(output.Origin),
        OriginDetails: output.OriginDetails !== undefined && output.OriginDetails !== null
            ? deserializeAws_restJson1OriginDetails(output.OriginDetails, context)
            : undefined,
        SourceId: __expectString(output.SourceId),
        UpdatedAt: output.UpdatedAt !== undefined && output.UpdatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.UpdatedAt))
            : undefined,
    };
};
var deserializeAws_restJson1Details = function (output, context) {
    return {
        ImportAssetFromSignedUrlJobErrorDetails: output.ImportAssetFromSignedUrlJobErrorDetails !== undefined &&
            output.ImportAssetFromSignedUrlJobErrorDetails !== null
            ? deserializeAws_restJson1ImportAssetFromSignedUrlJobErrorDetails(output.ImportAssetFromSignedUrlJobErrorDetails, context)
            : undefined,
        ImportAssetsFromS3JobErrorDetails: output.ImportAssetsFromS3JobErrorDetails !== undefined && output.ImportAssetsFromS3JobErrorDetails !== null
            ? deserializeAws_restJson1ListOfAssetSourceEntry(output.ImportAssetsFromS3JobErrorDetails, context)
            : undefined,
    };
};
var deserializeAws_restJson1Event = function (output, context) {
    return {
        RevisionPublished: output.RevisionPublished !== undefined && output.RevisionPublished !== null
            ? deserializeAws_restJson1RevisionPublished(output.RevisionPublished, context)
            : undefined,
    };
};
var deserializeAws_restJson1EventActionEntry = function (output, context) {
    return {
        Action: output.Action !== undefined && output.Action !== null
            ? deserializeAws_restJson1Action(output.Action, context)
            : undefined,
        Arn: __expectString(output.Arn),
        CreatedAt: output.CreatedAt !== undefined && output.CreatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.CreatedAt))
            : undefined,
        Event: output.Event !== undefined && output.Event !== null
            ? deserializeAws_restJson1Event(output.Event, context)
            : undefined,
        Id: __expectString(output.Id),
        UpdatedAt: output.UpdatedAt !== undefined && output.UpdatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.UpdatedAt))
            : undefined,
    };
};
var deserializeAws_restJson1ExportAssetsToS3ResponseDetails = function (output, context) {
    return {
        AssetDestinations: output.AssetDestinations !== undefined && output.AssetDestinations !== null
            ? deserializeAws_restJson1ListOfAssetDestinationEntry(output.AssetDestinations, context)
            : undefined,
        DataSetId: __expectString(output.DataSetId),
        Encryption: output.Encryption !== undefined && output.Encryption !== null
            ? deserializeAws_restJson1ExportServerSideEncryption(output.Encryption, context)
            : undefined,
        RevisionId: __expectString(output.RevisionId),
    };
};
var deserializeAws_restJson1ExportAssetToSignedUrlResponseDetails = function (output, context) {
    return {
        AssetId: __expectString(output.AssetId),
        DataSetId: __expectString(output.DataSetId),
        RevisionId: __expectString(output.RevisionId),
        SignedUrl: __expectString(output.SignedUrl),
        SignedUrlExpiresAt: output.SignedUrlExpiresAt !== undefined && output.SignedUrlExpiresAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.SignedUrlExpiresAt))
            : undefined,
    };
};
var deserializeAws_restJson1ExportRevisionsToS3ResponseDetails = function (output, context) {
    return {
        DataSetId: __expectString(output.DataSetId),
        Encryption: output.Encryption !== undefined && output.Encryption !== null
            ? deserializeAws_restJson1ExportServerSideEncryption(output.Encryption, context)
            : undefined,
        EventActionArn: __expectString(output.EventActionArn),
        RevisionDestinations: output.RevisionDestinations !== undefined && output.RevisionDestinations !== null
            ? deserializeAws_restJson1ListOfRevisionDestinationEntry(output.RevisionDestinations, context)
            : undefined,
    };
};
var deserializeAws_restJson1ExportServerSideEncryption = function (output, context) {
    return {
        KmsKeyArn: __expectString(output.KmsKeyArn),
        Type: __expectString(output.Type),
    };
};
var deserializeAws_restJson1ImportAssetFromApiGatewayApiResponseDetails = function (output, context) {
    return {
        ApiDescription: __expectString(output.ApiDescription),
        ApiId: __expectString(output.ApiId),
        ApiKey: __expectString(output.ApiKey),
        ApiName: __expectString(output.ApiName),
        ApiSpecificationMd5Hash: __expectString(output.ApiSpecificationMd5Hash),
        ApiSpecificationUploadUrl: __expectString(output.ApiSpecificationUploadUrl),
        ApiSpecificationUploadUrlExpiresAt: output.ApiSpecificationUploadUrlExpiresAt !== undefined && output.ApiSpecificationUploadUrlExpiresAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.ApiSpecificationUploadUrlExpiresAt))
            : undefined,
        DataSetId: __expectString(output.DataSetId),
        ProtocolType: __expectString(output.ProtocolType),
        RevisionId: __expectString(output.RevisionId),
        Stage: __expectString(output.Stage),
    };
};
var deserializeAws_restJson1ImportAssetFromSignedUrlJobErrorDetails = function (output, context) {
    return {
        AssetName: __expectString(output.AssetName),
    };
};
var deserializeAws_restJson1ImportAssetFromSignedUrlResponseDetails = function (output, context) {
    return {
        AssetName: __expectString(output.AssetName),
        DataSetId: __expectString(output.DataSetId),
        Md5Hash: __expectString(output.Md5Hash),
        RevisionId: __expectString(output.RevisionId),
        SignedUrl: __expectString(output.SignedUrl),
        SignedUrlExpiresAt: output.SignedUrlExpiresAt !== undefined && output.SignedUrlExpiresAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.SignedUrlExpiresAt))
            : undefined,
    };
};
var deserializeAws_restJson1ImportAssetsFromRedshiftDataSharesResponseDetails = function (output, context) {
    return {
        AssetSources: output.AssetSources !== undefined && output.AssetSources !== null
            ? deserializeAws_restJson1ListOfRedshiftDataShareAssetSourceEntry(output.AssetSources, context)
            : undefined,
        DataSetId: __expectString(output.DataSetId),
        RevisionId: __expectString(output.RevisionId),
    };
};
var deserializeAws_restJson1ImportAssetsFromS3ResponseDetails = function (output, context) {
    return {
        AssetSources: output.AssetSources !== undefined && output.AssetSources !== null
            ? deserializeAws_restJson1ListOfAssetSourceEntry(output.AssetSources, context)
            : undefined,
        DataSetId: __expectString(output.DataSetId),
        RevisionId: __expectString(output.RevisionId),
    };
};
var deserializeAws_restJson1JobEntry = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
        CreatedAt: output.CreatedAt !== undefined && output.CreatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.CreatedAt))
            : undefined,
        Details: output.Details !== undefined && output.Details !== null
            ? deserializeAws_restJson1ResponseDetails(output.Details, context)
            : undefined,
        Errors: output.Errors !== undefined && output.Errors !== null
            ? deserializeAws_restJson1ListOfJobError(output.Errors, context)
            : undefined,
        Id: __expectString(output.Id),
        State: __expectString(output.State),
        Type: __expectString(output.Type),
        UpdatedAt: output.UpdatedAt !== undefined && output.UpdatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.UpdatedAt))
            : undefined,
    };
};
var deserializeAws_restJson1JobError = function (output, context) {
    return {
        Code: __expectString(output.Code),
        Details: output.Details !== undefined && output.Details !== null
            ? deserializeAws_restJson1Details(output.Details, context)
            : undefined,
        LimitName: __expectString(output.LimitName),
        LimitValue: __limitedParseDouble(output.LimitValue),
        Message: __expectString(output.Message),
        ResourceId: __expectString(output.ResourceId),
        ResourceType: __expectString(output.ResourceType),
    };
};
var deserializeAws_restJson1ListOfAssetDestinationEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AssetDestinationEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfAssetEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AssetEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfAssetSourceEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AssetSourceEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfDataSetEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1DataSetEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfEventActionEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1EventActionEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfJobEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1JobEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfJobError = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1JobError(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfRedshiftDataShareAssetSourceEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RedshiftDataShareAssetSourceEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfRevisionDestinationEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RevisionDestinationEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1ListOfRevisionEntry = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1RevisionEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1MapOf__string = function (output, context) {
    return Object.entries(output).reduce(function (acc, _a) {
        var _b;
        var _c = __read(_a, 2), key = _c[0], value = _c[1];
        if (value === null) {
            return acc;
        }
        return __assign(__assign({}, acc), (_b = {}, _b[key] = __expectString(value), _b));
    }, {});
};
var deserializeAws_restJson1OriginDetails = function (output, context) {
    return {
        ProductId: __expectString(output.ProductId),
    };
};
var deserializeAws_restJson1RedshiftDataShareAsset = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
    };
};
var deserializeAws_restJson1RedshiftDataShareAssetSourceEntry = function (output, context) {
    return {
        DataShareArn: __expectString(output.DataShareArn),
    };
};
var deserializeAws_restJson1ResponseDetails = function (output, context) {
    return {
        ExportAssetToSignedUrl: output.ExportAssetToSignedUrl !== undefined && output.ExportAssetToSignedUrl !== null
            ? deserializeAws_restJson1ExportAssetToSignedUrlResponseDetails(output.ExportAssetToSignedUrl, context)
            : undefined,
        ExportAssetsToS3: output.ExportAssetsToS3 !== undefined && output.ExportAssetsToS3 !== null
            ? deserializeAws_restJson1ExportAssetsToS3ResponseDetails(output.ExportAssetsToS3, context)
            : undefined,
        ExportRevisionsToS3: output.ExportRevisionsToS3 !== undefined && output.ExportRevisionsToS3 !== null
            ? deserializeAws_restJson1ExportRevisionsToS3ResponseDetails(output.ExportRevisionsToS3, context)
            : undefined,
        ImportAssetFromApiGatewayApi: output.ImportAssetFromApiGatewayApi !== undefined && output.ImportAssetFromApiGatewayApi !== null
            ? deserializeAws_restJson1ImportAssetFromApiGatewayApiResponseDetails(output.ImportAssetFromApiGatewayApi, context)
            : undefined,
        ImportAssetFromSignedUrl: output.ImportAssetFromSignedUrl !== undefined && output.ImportAssetFromSignedUrl !== null
            ? deserializeAws_restJson1ImportAssetFromSignedUrlResponseDetails(output.ImportAssetFromSignedUrl, context)
            : undefined,
        ImportAssetsFromRedshiftDataShares: output.ImportAssetsFromRedshiftDataShares !== undefined && output.ImportAssetsFromRedshiftDataShares !== null
            ? deserializeAws_restJson1ImportAssetsFromRedshiftDataSharesResponseDetails(output.ImportAssetsFromRedshiftDataShares, context)
            : undefined,
        ImportAssetsFromS3: output.ImportAssetsFromS3 !== undefined && output.ImportAssetsFromS3 !== null
            ? deserializeAws_restJson1ImportAssetsFromS3ResponseDetails(output.ImportAssetsFromS3, context)
            : undefined,
    };
};
var deserializeAws_restJson1RevisionDestinationEntry = function (output, context) {
    return {
        Bucket: __expectString(output.Bucket),
        KeyPattern: __expectString(output.KeyPattern),
        RevisionId: __expectString(output.RevisionId),
    };
};
var deserializeAws_restJson1RevisionEntry = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
        Comment: __expectString(output.Comment),
        CreatedAt: output.CreatedAt !== undefined && output.CreatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.CreatedAt))
            : undefined,
        DataSetId: __expectString(output.DataSetId),
        Finalized: __expectBoolean(output.Finalized),
        Id: __expectString(output.Id),
        RevocationComment: __expectString(output.RevocationComment),
        Revoked: __expectBoolean(output.Revoked),
        RevokedAt: output.RevokedAt !== undefined && output.RevokedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.RevokedAt))
            : undefined,
        SourceId: __expectString(output.SourceId),
        UpdatedAt: output.UpdatedAt !== undefined && output.UpdatedAt !== null
            ? __expectNonNull(__parseRfc3339DateTime(output.UpdatedAt))
            : undefined,
    };
};
var deserializeAws_restJson1RevisionPublished = function (output, context) {
    return {
        DataSetId: __expectString(output.DataSetId),
    };
};
var deserializeAws_restJson1S3SnapshotAsset = function (output, context) {
    return {
        Size: __limitedParseDouble(output.Size),
    };
};
var deserializeMetadata = function (output) {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
var collectBody = function (streamBody, context) {
    if (streamBody === void 0) { streamBody = new Uint8Array(); }
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
var collectBodyString = function (streamBody, context) {
    return collectBody(streamBody, context).then(function (body) { return context.utf8Encoder(body); });
};
var isSerializableHeaderValue = function (value) {
    return value !== undefined &&
        value !== null &&
        value !== "" &&
        (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
        (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
};
var parseBody = function (streamBody, context) {
    return collectBodyString(streamBody, context).then(function (encoded) {
        if (encoded.length) {
            return JSON.parse(encoded);
        }
        return {};
    });
};
var loadRestJsonErrorCode = function (output, data) {
    var findKey = function (object, key) { return Object.keys(object).find(function (k) { return k.toLowerCase() === key.toLowerCase(); }); };
    var sanitizeErrorCode = function (rawValue) {
        var cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    var headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
