import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { DeleteEventActionRequest } from "../models/models_0";
export interface DeleteEventActionCommandInput extends DeleteEventActionRequest {
}
export interface DeleteEventActionCommandOutput extends __MetadataBearer {
}
/**
 * <p>This operation deletes the event action.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { DataExchangeClient, DeleteEventActionCommand } from "@aws-sdk/client-dataexchange"; // ES Modules import
 * // const { DataExchangeClient, DeleteEventActionCommand } = require("@aws-sdk/client-dataexchange"); // CommonJS import
 * const client = new DataExchangeClient(config);
 * const command = new DeleteEventActionCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link DeleteEventActionCommandInput} for command's `input` shape.
 * @see {@link DeleteEventActionCommandOutput} for command's `response` shape.
 * @see {@link DataExchangeClientResolvedConfig | config} for DataExchangeClient's `config` shape.
 *
 */
export declare class DeleteEventActionCommand extends $Command<DeleteEventActionCommandInput, DeleteEventActionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: DeleteEventActionCommandInput;
    constructor(input: DeleteEventActionCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteEventActionCommandInput, DeleteEventActionCommandOutput>;
    private serialize;
    private deserialize;
}
