import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { ListEventActionsRequest, ListEventActionsResponse } from "../models/models_0";
export interface ListEventActionsCommandInput extends ListEventActionsRequest {
}
export interface ListEventActionsCommandOutput extends ListEventActionsResponse, __MetadataBearer {
}
/**
 * <p>This operation lists your event actions.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { DataExchangeClient, ListEventActionsCommand } from "@aws-sdk/client-dataexchange"; // ES Modules import
 * // const { DataExchangeClient, ListEventActionsCommand } = require("@aws-sdk/client-dataexchange"); // CommonJS import
 * const client = new DataExchangeClient(config);
 * const command = new ListEventActionsCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link ListEventActionsCommandInput} for command's `input` shape.
 * @see {@link ListEventActionsCommandOutput} for command's `response` shape.
 * @see {@link DataExchangeClientResolvedConfig | config} for DataExchangeClient's `config` shape.
 *
 */
export declare class ListEventActionsCommand extends $Command<ListEventActionsCommandInput, ListEventActionsCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: ListEventActionsCommandInput;
    constructor(input: ListEventActionsCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListEventActionsCommandInput, ListEventActionsCommandOutput>;
    private serialize;
    private deserialize;
}
