import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { UpdateEventActionRequest, UpdateEventActionResponse } from "../models/models_0";
export interface UpdateEventActionCommandInput extends UpdateEventActionRequest {
}
export interface UpdateEventActionCommandOutput extends UpdateEventActionResponse, __MetadataBearer {
}
/**
 * <p>This operation updates the event action.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { DataExchangeClient, UpdateEventActionCommand } from "@aws-sdk/client-dataexchange"; // ES Modules import
 * // const { DataExchangeClient, UpdateEventActionCommand } = require("@aws-sdk/client-dataexchange"); // CommonJS import
 * const client = new DataExchangeClient(config);
 * const command = new UpdateEventActionCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link UpdateEventActionCommandInput} for command's `input` shape.
 * @see {@link UpdateEventActionCommandOutput} for command's `response` shape.
 * @see {@link DataExchangeClientResolvedConfig | config} for DataExchangeClient's `config` shape.
 *
 */
export declare class UpdateEventActionCommand extends $Command<UpdateEventActionCommandInput, UpdateEventActionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: UpdateEventActionCommandInput;
    constructor(input: UpdateEventActionCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateEventActionCommandInput, UpdateEventActionCommandOutput>;
    private serialize;
    private deserialize;
}
