import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { CreateDataSetRequest, CreateDataSetResponse } from "../models/models_0";
export interface CreateDataSetCommandInput extends CreateDataSetRequest {
}
export interface CreateDataSetCommandOutput extends CreateDataSetResponse, __MetadataBearer {
}

export declare class CreateDataSetCommand extends $Command<CreateDataSetCommandInput, CreateDataSetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: CreateDataSetCommandInput;
    constructor(input: CreateDataSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateDataSetCommandInput, CreateDataSetCommandOutput>;
    private serialize;
    private deserialize;
}
