import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { CreateEventActionRequest, CreateEventActionResponse } from "../models/models_0";
export interface CreateEventActionCommandInput extends CreateEventActionRequest {
}
export interface CreateEventActionCommandOutput extends CreateEventActionResponse, __MetadataBearer {
}

export declare class CreateEventActionCommand extends $Command<CreateEventActionCommandInput, CreateEventActionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: CreateEventActionCommandInput;
    constructor(input: CreateEventActionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateEventActionCommandInput, CreateEventActionCommandOutput>;
    private serialize;
    private deserialize;
}
