import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { CreateRevisionRequest, CreateRevisionResponse } from "../models/models_0";
export interface CreateRevisionCommandInput extends CreateRevisionRequest {
}
export interface CreateRevisionCommandOutput extends CreateRevisionResponse, __MetadataBearer {
}

export declare class CreateRevisionCommand extends $Command<CreateRevisionCommandInput, CreateRevisionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: CreateRevisionCommandInput;
    constructor(input: CreateRevisionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateRevisionCommandInput, CreateRevisionCommandOutput>;
    private serialize;
    private deserialize;
}
