import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { DeleteAssetRequest } from "../models/models_0";
export interface DeleteAssetCommandInput extends DeleteAssetRequest {
}
export interface DeleteAssetCommandOutput extends __MetadataBearer {
}

export declare class DeleteAssetCommand extends $Command<DeleteAssetCommandInput, DeleteAssetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: DeleteAssetCommandInput;
    constructor(input: DeleteAssetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteAssetCommandInput, DeleteAssetCommandOutput>;
    private serialize;
    private deserialize;
}
