import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { DeleteDataSetRequest } from "../models/models_0";
export interface DeleteDataSetCommandInput extends DeleteDataSetRequest {
}
export interface DeleteDataSetCommandOutput extends __MetadataBearer {
}

export declare class DeleteDataSetCommand extends $Command<DeleteDataSetCommandInput, DeleteDataSetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: DeleteDataSetCommandInput;
    constructor(input: DeleteDataSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteDataSetCommandInput, DeleteDataSetCommandOutput>;
    private serialize;
    private deserialize;
}
