import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { DeleteEventActionRequest } from "../models/models_0";
export interface DeleteEventActionCommandInput extends DeleteEventActionRequest {
}
export interface DeleteEventActionCommandOutput extends __MetadataBearer {
}

export declare class DeleteEventActionCommand extends $Command<DeleteEventActionCommandInput, DeleteEventActionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: DeleteEventActionCommandInput;
    constructor(input: DeleteEventActionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteEventActionCommandInput, DeleteEventActionCommandOutput>;
    private serialize;
    private deserialize;
}
