import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { DeleteRevisionRequest } from "../models/models_0";
export interface DeleteRevisionCommandInput extends DeleteRevisionRequest {
}
export interface DeleteRevisionCommandOutput extends __MetadataBearer {
}

export declare class DeleteRevisionCommand extends $Command<DeleteRevisionCommandInput, DeleteRevisionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: DeleteRevisionCommandInput;
    constructor(input: DeleteRevisionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteRevisionCommandInput, DeleteRevisionCommandOutput>;
    private serialize;
    private deserialize;
}
