import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { GetAssetRequest, GetAssetResponse } from "../models/models_0";
export interface GetAssetCommandInput extends GetAssetRequest {
}
export interface GetAssetCommandOutput extends GetAssetResponse, __MetadataBearer {
}

export declare class GetAssetCommand extends $Command<GetAssetCommandInput, GetAssetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: GetAssetCommandInput;
    constructor(input: GetAssetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetAssetCommandInput, GetAssetCommandOutput>;
    private serialize;
    private deserialize;
}
