import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { GetDataSetRequest, GetDataSetResponse } from "../models/models_0";
export interface GetDataSetCommandInput extends GetDataSetRequest {
}
export interface GetDataSetCommandOutput extends GetDataSetResponse, __MetadataBearer {
}

export declare class GetDataSetCommand extends $Command<GetDataSetCommandInput, GetDataSetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: GetDataSetCommandInput;
    constructor(input: GetDataSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetDataSetCommandInput, GetDataSetCommandOutput>;
    private serialize;
    private deserialize;
}
