import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { GetEventActionRequest, GetEventActionResponse } from "../models/models_0";
export interface GetEventActionCommandInput extends GetEventActionRequest {
}
export interface GetEventActionCommandOutput extends GetEventActionResponse, __MetadataBearer {
}

export declare class GetEventActionCommand extends $Command<GetEventActionCommandInput, GetEventActionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: GetEventActionCommandInput;
    constructor(input: GetEventActionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetEventActionCommandInput, GetEventActionCommandOutput>;
    private serialize;
    private deserialize;
}
