import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { GetRevisionRequest, GetRevisionResponse } from "../models/models_0";
export interface GetRevisionCommandInput extends GetRevisionRequest {
}
export interface GetRevisionCommandOutput extends GetRevisionResponse, __MetadataBearer {
}

export declare class GetRevisionCommand extends $Command<GetRevisionCommandInput, GetRevisionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: GetRevisionCommandInput;
    constructor(input: GetRevisionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetRevisionCommandInput, GetRevisionCommandOutput>;
    private serialize;
    private deserialize;
}
