import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { ListDataSetRevisionsRequest, ListDataSetRevisionsResponse } from "../models/models_0";
export interface ListDataSetRevisionsCommandInput extends ListDataSetRevisionsRequest {
}
export interface ListDataSetRevisionsCommandOutput extends ListDataSetRevisionsResponse, __MetadataBearer {
}

export declare class ListDataSetRevisionsCommand extends $Command<ListDataSetRevisionsCommandInput, ListDataSetRevisionsCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: ListDataSetRevisionsCommandInput;
    constructor(input: ListDataSetRevisionsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListDataSetRevisionsCommandInput, ListDataSetRevisionsCommandOutput>;
    private serialize;
    private deserialize;
}
