import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { ListDataSetsRequest, ListDataSetsResponse } from "../models/models_0";
export interface ListDataSetsCommandInput extends ListDataSetsRequest {
}
export interface ListDataSetsCommandOutput extends ListDataSetsResponse, __MetadataBearer {
}

export declare class ListDataSetsCommand extends $Command<ListDataSetsCommandInput, ListDataSetsCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: ListDataSetsCommandInput;
    constructor(input: ListDataSetsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListDataSetsCommandInput, ListDataSetsCommandOutput>;
    private serialize;
    private deserialize;
}
