import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { ListEventActionsRequest, ListEventActionsResponse } from "../models/models_0";
export interface ListEventActionsCommandInput extends ListEventActionsRequest {
}
export interface ListEventActionsCommandOutput extends ListEventActionsResponse, __MetadataBearer {
}

export declare class ListEventActionsCommand extends $Command<ListEventActionsCommandInput, ListEventActionsCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: ListEventActionsCommandInput;
    constructor(input: ListEventActionsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListEventActionsCommandInput, ListEventActionsCommandOutput>;
    private serialize;
    private deserialize;
}
