import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { ListRevisionAssetsRequest, ListRevisionAssetsResponse } from "../models/models_0";
export interface ListRevisionAssetsCommandInput extends ListRevisionAssetsRequest {
}
export interface ListRevisionAssetsCommandOutput extends ListRevisionAssetsResponse, __MetadataBearer {
}

export declare class ListRevisionAssetsCommand extends $Command<ListRevisionAssetsCommandInput, ListRevisionAssetsCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: ListRevisionAssetsCommandInput;
    constructor(input: ListRevisionAssetsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListRevisionAssetsCommandInput, ListRevisionAssetsCommandOutput>;
    private serialize;
    private deserialize;
}
