import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { RevokeRevisionRequest, RevokeRevisionResponse } from "../models/models_0";
export interface RevokeRevisionCommandInput extends RevokeRevisionRequest {
}
export interface RevokeRevisionCommandOutput extends RevokeRevisionResponse, __MetadataBearer {
}

export declare class RevokeRevisionCommand extends $Command<RevokeRevisionCommandInput, RevokeRevisionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: RevokeRevisionCommandInput;
    constructor(input: RevokeRevisionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<RevokeRevisionCommandInput, RevokeRevisionCommandOutput>;
    private serialize;
    private deserialize;
}
