import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { SendApiAssetRequest, SendApiAssetResponse } from "../models/models_0";
export interface SendApiAssetCommandInput extends SendApiAssetRequest {
}
export interface SendApiAssetCommandOutput extends SendApiAssetResponse, __MetadataBearer {
}

export declare class SendApiAssetCommand extends $Command<SendApiAssetCommandInput, SendApiAssetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: SendApiAssetCommandInput;
    constructor(input: SendApiAssetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<SendApiAssetCommandInput, SendApiAssetCommandOutput>;
    private serialize;
    private deserialize;
}
