import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { StartJobRequest, StartJobResponse } from "../models/models_0";
export interface StartJobCommandInput extends StartJobRequest {
}
export interface StartJobCommandOutput extends StartJobResponse, __MetadataBearer {
}

export declare class StartJobCommand extends $Command<StartJobCommandInput, StartJobCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: StartJobCommandInput;
    constructor(input: StartJobCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<StartJobCommandInput, StartJobCommandOutput>;
    private serialize;
    private deserialize;
}
