import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { UpdateAssetRequest, UpdateAssetResponse } from "../models/models_0";
export interface UpdateAssetCommandInput extends UpdateAssetRequest {
}
export interface UpdateAssetCommandOutput extends UpdateAssetResponse, __MetadataBearer {
}

export declare class UpdateAssetCommand extends $Command<UpdateAssetCommandInput, UpdateAssetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: UpdateAssetCommandInput;
    constructor(input: UpdateAssetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateAssetCommandInput, UpdateAssetCommandOutput>;
    private serialize;
    private deserialize;
}
