import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { UpdateDataSetRequest, UpdateDataSetResponse } from "../models/models_0";
export interface UpdateDataSetCommandInput extends UpdateDataSetRequest {
}
export interface UpdateDataSetCommandOutput extends UpdateDataSetResponse, __MetadataBearer {
}

export declare class UpdateDataSetCommand extends $Command<UpdateDataSetCommandInput, UpdateDataSetCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: UpdateDataSetCommandInput;
    constructor(input: UpdateDataSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateDataSetCommandInput, UpdateDataSetCommandOutput>;
    private serialize;
    private deserialize;
}
