import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { UpdateEventActionRequest, UpdateEventActionResponse } from "../models/models_0";
export interface UpdateEventActionCommandInput extends UpdateEventActionRequest {
}
export interface UpdateEventActionCommandOutput extends UpdateEventActionResponse, __MetadataBearer {
}

export declare class UpdateEventActionCommand extends $Command<UpdateEventActionCommandInput, UpdateEventActionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: UpdateEventActionCommandInput;
    constructor(input: UpdateEventActionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateEventActionCommandInput, UpdateEventActionCommandOutput>;
    private serialize;
    private deserialize;
}
