import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DataExchangeClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../DataExchangeClient";
import { UpdateRevisionRequest, UpdateRevisionResponse } from "../models/models_0";
export interface UpdateRevisionCommandInput extends UpdateRevisionRequest {
}
export interface UpdateRevisionCommandOutput extends UpdateRevisionResponse, __MetadataBearer {
}

export declare class UpdateRevisionCommand extends $Command<UpdateRevisionCommandInput, UpdateRevisionCommandOutput, DataExchangeClientResolvedConfig> {
    readonly input: UpdateRevisionCommandInput;
    constructor(input: UpdateRevisionCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: DataExchangeClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateRevisionCommandInput, UpdateRevisionCommandOutput>;
    private serialize;
    private deserialize;
}
