import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { CancelJobCommandInput, CancelJobCommandOutput } from "../commands/CancelJobCommand";
import { CreateDataSetCommandInput, CreateDataSetCommandOutput } from "../commands/CreateDataSetCommand";
import { CreateEventActionCommandInput, CreateEventActionCommandOutput } from "../commands/CreateEventActionCommand";
import { CreateJobCommandInput, CreateJobCommandOutput } from "../commands/CreateJobCommand";
import { CreateRevisionCommandInput, CreateRevisionCommandOutput } from "../commands/CreateRevisionCommand";
import { DeleteAssetCommandInput, DeleteAssetCommandOutput } from "../commands/DeleteAssetCommand";
import { DeleteDataSetCommandInput, DeleteDataSetCommandOutput } from "../commands/DeleteDataSetCommand";
import { DeleteEventActionCommandInput, DeleteEventActionCommandOutput } from "../commands/DeleteEventActionCommand";
import { DeleteRevisionCommandInput, DeleteRevisionCommandOutput } from "../commands/DeleteRevisionCommand";
import { GetAssetCommandInput, GetAssetCommandOutput } from "../commands/GetAssetCommand";
import { GetDataSetCommandInput, GetDataSetCommandOutput } from "../commands/GetDataSetCommand";
import { GetEventActionCommandInput, GetEventActionCommandOutput } from "../commands/GetEventActionCommand";
import { GetJobCommandInput, GetJobCommandOutput } from "../commands/GetJobCommand";
import { GetRevisionCommandInput, GetRevisionCommandOutput } from "../commands/GetRevisionCommand";
import { ListDataSetRevisionsCommandInput, ListDataSetRevisionsCommandOutput } from "../commands/ListDataSetRevisionsCommand";
import { ListDataSetsCommandInput, ListDataSetsCommandOutput } from "../commands/ListDataSetsCommand";
import { ListEventActionsCommandInput, ListEventActionsCommandOutput } from "../commands/ListEventActionsCommand";
import { ListJobsCommandInput, ListJobsCommandOutput } from "../commands/ListJobsCommand";
import { ListRevisionAssetsCommandInput, ListRevisionAssetsCommandOutput } from "../commands/ListRevisionAssetsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { RevokeRevisionCommandInput, RevokeRevisionCommandOutput } from "../commands/RevokeRevisionCommand";
import { SendApiAssetCommandInput, SendApiAssetCommandOutput } from "../commands/SendApiAssetCommand";
import { StartJobCommandInput, StartJobCommandOutput } from "../commands/StartJobCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateAssetCommandInput, UpdateAssetCommandOutput } from "../commands/UpdateAssetCommand";
import { UpdateDataSetCommandInput, UpdateDataSetCommandOutput } from "../commands/UpdateDataSetCommand";
import { UpdateEventActionCommandInput, UpdateEventActionCommandOutput } from "../commands/UpdateEventActionCommand";
import { UpdateRevisionCommandInput, UpdateRevisionCommandOutput } from "../commands/UpdateRevisionCommand";
export declare const serializeAws_restJson1CancelJobCommand: (input: CancelJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateDataSetCommand: (input: CreateDataSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateEventActionCommand: (input: CreateEventActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateJobCommand: (input: CreateJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateRevisionCommand: (input: CreateRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteAssetCommand: (input: DeleteAssetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteDataSetCommand: (input: DeleteDataSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteEventActionCommand: (input: DeleteEventActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteRevisionCommand: (input: DeleteRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetAssetCommand: (input: GetAssetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetDataSetCommand: (input: GetDataSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetEventActionCommand: (input: GetEventActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetJobCommand: (input: GetJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetRevisionCommand: (input: GetRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListDataSetRevisionsCommand: (input: ListDataSetRevisionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListDataSetsCommand: (input: ListDataSetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListEventActionsCommand: (input: ListEventActionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListJobsCommand: (input: ListJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListRevisionAssetsCommand: (input: ListRevisionAssetsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1RevokeRevisionCommand: (input: RevokeRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1SendApiAssetCommand: (input: SendApiAssetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1StartJobCommand: (input: StartJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateAssetCommand: (input: UpdateAssetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateDataSetCommand: (input: UpdateDataSetCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateEventActionCommand: (input: UpdateEventActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateRevisionCommand: (input: UpdateRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_restJson1CancelJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelJobCommandOutput>;
export declare const deserializeAws_restJson1CreateDataSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDataSetCommandOutput>;
export declare const deserializeAws_restJson1CreateEventActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateEventActionCommandOutput>;
export declare const deserializeAws_restJson1CreateJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateJobCommandOutput>;
export declare const deserializeAws_restJson1CreateRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRevisionCommandOutput>;
export declare const deserializeAws_restJson1DeleteAssetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAssetCommandOutput>;
export declare const deserializeAws_restJson1DeleteDataSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDataSetCommandOutput>;
export declare const deserializeAws_restJson1DeleteEventActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteEventActionCommandOutput>;
export declare const deserializeAws_restJson1DeleteRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRevisionCommandOutput>;
export declare const deserializeAws_restJson1GetAssetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAssetCommandOutput>;
export declare const deserializeAws_restJson1GetDataSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDataSetCommandOutput>;
export declare const deserializeAws_restJson1GetEventActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetEventActionCommandOutput>;
export declare const deserializeAws_restJson1GetJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetJobCommandOutput>;
export declare const deserializeAws_restJson1GetRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRevisionCommandOutput>;
export declare const deserializeAws_restJson1ListDataSetRevisionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDataSetRevisionsCommandOutput>;
export declare const deserializeAws_restJson1ListDataSetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDataSetsCommandOutput>;
export declare const deserializeAws_restJson1ListEventActionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListEventActionsCommandOutput>;
export declare const deserializeAws_restJson1ListJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListJobsCommandOutput>;
export declare const deserializeAws_restJson1ListRevisionAssetsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListRevisionAssetsCommandOutput>;
export declare const deserializeAws_restJson1ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_restJson1RevokeRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RevokeRevisionCommandOutput>;
export declare const deserializeAws_restJson1SendApiAssetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<SendApiAssetCommandOutput>;
export declare const deserializeAws_restJson1StartJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartJobCommandOutput>;
export declare const deserializeAws_restJson1TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_restJson1UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
export declare const deserializeAws_restJson1UpdateAssetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateAssetCommandOutput>;
export declare const deserializeAws_restJson1UpdateDataSetCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDataSetCommandOutput>;
export declare const deserializeAws_restJson1UpdateEventActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateEventActionCommandOutput>;
export declare const deserializeAws_restJson1UpdateRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRevisionCommandOutput>;
